SystemOrganization addCategory: #'Pier-Model-Core'!
SystemOrganization addCategory: #'Pier-Model-Kernel'!
SystemOrganization addCategory: #'Pier-Model-Persistence'!
SystemOrganization addCategory: #'Pier-Model-Structure'!
SystemOrganization addCategory: #'Pier-Model-Document'!
SystemOrganization addCategory: #'Pier-Model-Command'!
SystemOrganization addCategory: #'Pier-Model-Exception'!
SystemOrganization addCategory: #'Pier-Model-Visitor'!
SystemOrganization addCategory: #'Pier-Model-Magritte'!
SystemOrganization addCategory: #'Pier-Model-Utilities'!

!MAStringReader methodsFor: '*pier-model-visiting-description' stamp: 'lr 11/17/2005 15:17'!
visitStructureDescription: aDescription
	self object: (PRPathLookup
		start: self context structure
		path: self contents).! !

SmaCCScanner subclass: #PRTextScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRTextScanner class methodsFor: 'generated-comments' stamp: 'lr 2/18/2006 15:55'!
scannerDefinitionComment

	"# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

<linktext>	: [^\*\+\>\@]* ;
<link>		: \* (<linktext> \>)? <linktext> (\@ <linktext>)? \*
			| \+ (<linktext> \>)? <linktext> (\@ <linktext>)? \+ ;

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

<xmlclose>	: \< \/ [^\>]+ \> ;
<xmlshort>	: \< [^\>\/]+ \/ \> ;
<xmlopen>	: \< [^\>]+ \> ;

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

<escaped>	: \\ . ;

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

<string>		: [^\*\+\<\\]+ ;
<any>		: . ;

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #"! !

!PRTextScanner methodsFor: 'generated-tokens' stamp: 'lr 2/18/2006 15:55'!
emptySymbolTokenId
	^16! !

!PRTextScanner methodsFor: 'generated-tokens' stamp: 'lr 2/18/2006 15:55'!
errorTokenId
	^17! !

!PRTextScanner methodsFor: 'generated-scanner' stamp: 'lr 2/18/2006 15:55'!
scan1
	
	[ self step.
	currentCharacter <= $) or: 
			[ (currentCharacter between: $, and: $=) 
				or: [ currentCharacter == $? or: [ currentCharacter >= $A ] ] ] ] 
			whileTrue.
	currentCharacter == $* ifTrue: [ ^ self recordAndReportMatch: #(1 ) ].
	currentCharacter == $@ ifTrue: [ ^ self scan2 ].
	^ self reportLastMatch.! !

!PRTextScanner methodsFor: 'generated-scanner' stamp: 'lr 2/18/2006 15:55'!
scan2
	
	[ self step.
	currentCharacter <= $) or: 
			[ (currentCharacter between: $, and: $=) 
				or: [ currentCharacter == $? or: [ currentCharacter >= $A ] ] ] ] 
			whileTrue.
	currentCharacter == $* ifTrue: [ ^ self recordAndReportMatch: #(1 ) ].
	^ self reportLastMatch.! !

!PRTextScanner methodsFor: 'generated-scanner' stamp: 'lr 2/18/2006 15:55'!
scan3
	
	[ self step.
	currentCharacter <= $) or: 
			[ (currentCharacter between: $, and: $=) 
				or: [ currentCharacter == $? or: [ currentCharacter >= $A ] ] ] ] 
			whileTrue.
	currentCharacter == $+ ifTrue: [ ^ self recordAndReportMatch: #(1 ) ].
	currentCharacter == $@ ifTrue: [ ^ self scan4 ].
	^ self reportLastMatch.! !

!PRTextScanner methodsFor: 'generated-scanner' stamp: 'lr 2/18/2006 15:55'!
scan4
	
	[ self step.
	currentCharacter <= $) or: 
			[ (currentCharacter between: $, and: $=) 
				or: [ currentCharacter == $? or: [ currentCharacter >= $A ] ] ] ] 
			whileTrue.
	currentCharacter == $+ ifTrue: [ ^ self recordAndReportMatch: #(1 ) ].
	^ self reportLastMatch.! !

!PRTextScanner methodsFor: 'generated-scanner' stamp: 'lr 2/18/2006 15:55'!
scanForToken
	self step.
	(currentCharacter <= $) or: 
			[ (currentCharacter between: $, and: $;) 
				or: [ (currentCharacter between: $= and: $[) or: [ currentCharacter >= $] ] ] ]) 
		ifTrue: 
			[ self recordMatch: #(6 7 ).
			self step.
			(currentCharacter <= $) or: 
					[ (currentCharacter between: $, and: $;) 
						or: [ (currentCharacter between: $= and: $[) or: [ currentCharacter >= $] ] ] ]) 
				ifTrue: 
					[ 
					[ self recordMatch: #(6 ).
					self step.
					currentCharacter <= $) or: 
							[ (currentCharacter between: $, and: $;) 
								or: [ (currentCharacter between: $= and: $[) or: [ currentCharacter >= $] ] ] ] ] 
							whileTrue.
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter == $* 
		ifTrue: 
			[ self recordMatch: #(7 ).
			self step.
			(currentCharacter <= $) or: 
					[ (currentCharacter between: $, and: $=) 
						or: [ currentCharacter == $? or: [ currentCharacter >= $A ] ] ]) 
				ifTrue: 
					[ 
					[ self step.
					currentCharacter <= $) or: 
							[ (currentCharacter between: $, and: $=) 
								or: [ currentCharacter == $? or: [ currentCharacter >= $A ] ] ] ] 
							whileTrue.
					currentCharacter == $* ifTrue: [ ^ self recordAndReportMatch: #(1 ) ].
					currentCharacter == $> ifTrue: [ ^ self scan1 ].
					currentCharacter == $@ ifTrue: [ ^ self scan2 ].
					^ self reportLastMatch ].
			currentCharacter == $* ifTrue: [ ^ self recordAndReportMatch: #(1 ) ].
			currentCharacter == $> ifTrue: [ ^ self scan1 ].
			currentCharacter == $@ ifTrue: [ ^ self scan2 ].
			^ self reportLastMatch ].
	currentCharacter == $+ 
		ifTrue: 
			[ self recordMatch: #(7 ).
			self step.
			(currentCharacter <= $) or: 
					[ (currentCharacter between: $, and: $=) 
						or: [ currentCharacter == $? or: [ currentCharacter >= $A ] ] ]) 
				ifTrue: 
					[ 
					[ self step.
					currentCharacter <= $) or: 
							[ (currentCharacter between: $, and: $=) 
								or: [ currentCharacter == $? or: [ currentCharacter >= $A ] ] ] ] 
							whileTrue.
					currentCharacter == $+ ifTrue: [ ^ self recordAndReportMatch: #(1 ) ].
					currentCharacter == $> ifTrue: [ ^ self scan3 ].
					currentCharacter == $@ ifTrue: [ ^ self scan4 ].
					^ self reportLastMatch ].
			currentCharacter == $+ ifTrue: [ ^ self recordAndReportMatch: #(1 ) ].
			currentCharacter == $> ifTrue: [ ^ self scan3 ].
			currentCharacter == $@ ifTrue: [ ^ self scan4 ].
			^ self reportLastMatch ].
	currentCharacter == $< 
		ifTrue: 
			[ self recordMatch: #(7 ).
			self step.
			(currentCharacter <= $. 
				or: [ (currentCharacter between: $0 and: $=) or: [ currentCharacter >= $? ] ]) 
					ifTrue: 
						[ 
						[ self step.
						currentCharacter <= $. 
							or: [ (currentCharacter between: $0 and: $=) or: [ currentCharacter >= $? ] ] ] 
								whileTrue.
						currentCharacter == $/ 
							ifTrue: 
								[ self step.
								currentCharacter ~~ $> 
									ifTrue: 
										[ 
										[ self step.
										currentCharacter ~~ $> ] whileTrue.
										^ self recordAndReportMatch: #(4 ) ].
								currentCharacter == $> ifTrue: [ ^ self recordAndReportMatch: #(3 4 ) ].
								^ self reportLastMatch ].
						currentCharacter == $> ifTrue: [ ^ self recordAndReportMatch: #(4 ) ].
						^ self reportLastMatch ].
			currentCharacter == $/ 
				ifTrue: 
					[ self step.
					currentCharacter ~~ $> 
						ifTrue: 
							[ 
							[ self step.
							currentCharacter ~~ $> ] whileTrue.
							^ self recordAndReportMatch: #(2 4 ) ].
					currentCharacter == $> ifTrue: [ ^ self recordAndReportMatch: #(4 ) ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter == $\ 
		ifTrue: 
			[ self recordMatch: #(7 ).
			self step.
			^ self recordAndReportMatch: #(5 ) ].
	^ self reportLastMatch.! !

!MABinaryWriter methodsFor: '*pier-model-visiting-description' stamp: 'lr 11/17/2005 15:17'!
visitStructureDescription: aDescription
	self visitDescription: aDescription.
	stream nextPut: (PRPathReference to: self object).! !

!Object methodsFor: '*pier-model' stamp: 'lr 4/17/2005 11:57'!
acceptDecorated: aVisitor
	self accept: aVisitor.! !

!Object methodsFor: '*pier-model' stamp: 'lr 12/21/2005 17:41'!
accept: aVisitor
	self subclassResponsibility.! !

Object subclass: #PRDocumentScanner
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

PRDocumentScanner class
	instanceVariableNames: 'PrefixRegistry'!

!PRDocumentScanner class methodsFor: 'initialization' stamp: 'lr 2/19/2006 10:18'!
initialize
	self registerDefaultSelector: #parseParagraph.
	self registerPrefix: $@ selector: #parseAnchor.
	self registerPrefix: $!! selector: #parseHeader.
	self registerPrefix: $# selector: #parseList.
	self registerPrefix: $- selector: #parseList.
	self registerPrefix: $| selector: #parseTable.
	self registerPrefix: $_ selector: #parseRule.
	self registerPrefix: $= selector: #parsePreformatted.! !

!PRDocumentScanner class methodsFor: 'instance creation' stamp: 'lr 2/19/2006 10:01'!
on: aStream
	^ self new
		setStream: aStream;
		yourself.! !

!PRDocumentScanner class methodsFor: 'accessing' stamp: 'lr 2/19/2006 10:02'!
parseStream: aStream 
	^ (self on: aStream) parse.! !

!PRDocumentScanner class methodsFor: 'accessing' stamp: 'lr 2/19/2006 09:58'!
parse: aString
	^ self parseStream: aString readStream.! !

!PRDocumentScanner class methodsFor: 'initialization' stamp: 'lr 2/19/2006 10:17'!
registerDefaultSelector: aSelector
	PrefixRegistry := Array new: 256 withAll: aSelector.! !

!PRDocumentScanner class methodsFor: 'initialization' stamp: 'lr 2/19/2006 10:18'!
registerPrefix: aCharacter selector: aSelector
	PrefixRegistry at: aCharacter asciiValue + 1 put: aSelector.! !

!PRDocumentScanner methodsFor: 'parsing' stamp: 'lr 2/19/2006 10:02'!
parse
	! !

!PRDocumentScanner methodsFor: 'parsing-document' stamp: 'lr 2/19/2006 10:28'!
parseAnchor
	"<lineprefix: $@>"

	stream next.
	self addAnchor: self parseLine.! !

!PRDocumentScanner methodsFor: 'parsing-document' stamp: 'lr 2/19/2006 10:26'!
parseBlank
	"<lineprefix: Character cr>
	<lineprefix: Character lf>"

	[ stream peek = Character cr or: [ stream peek = Character lf ] ]
		whileTrue: [ stream next ].! !

!PRDocumentScanner methodsFor: 'parsing-document' stamp: 'lr 2/19/2006 10:25'!
parseHeader
	"<parserprefix: $!!>"

	| level |
	level := 0.
	[ stream peek = $!! ] 
		whileTrue: [ level := level + 1 ].
	^ self createHeading: self parseLine level: level.! !

!PRDocumentScanner methodsFor: 'parsing-document' stamp: 'lr 2/19/2006 10:24'!
parseLine! !

!PRDocumentScanner methodsFor: 'parsing-document' stamp: 'lr 2/19/2006 10:30'!
parseList
	"<lineprefix: $#>
	 <lineprefix: $->"

	| type |
	type := String streamContents: [ :output |
		[ stream peek = $# or: [ stream peek = $- ] ]
			whileTrue: [ output nextPut: stream next ] ].
	self addLine: self parseLine ofType: type.! !

!PRDocumentScanner methodsFor: 'parsing-document' stamp: 'lr 2/19/2006 10:28'!
parseParagraph
	self addParagraph: self parseLine.! !

!PRDocumentScanner methodsFor: 'parsing-document' stamp: 'lr 2/19/2006 10:27'!
parsePreformatted
	"<lineprefix: $=>"

	stream next.
	self addPreformatted: self parseLine.! !

!PRDocumentScanner methodsFor: 'parsing-document' stamp: 'lr 2/19/2006 10:27'!
parseRule
	"<lineprefix: $_>"
	
	self createRule.
	self parseLine.! !

!PRDocumentScanner methodsFor: 'parsing-document' stamp: 'lr 2/19/2006 10:20'!
parseTable! !

!PRDocumentScanner methodsFor: 'accessing' stamp: 'lr 2/19/2006 10:12'!
prefixes
	"This is a table of line-prefixes for parsing wiki-documents. Later on this table shold be  stored as method pragmas of the form <prefix: $a do: #parseAnchor>, so that the parser can be easily customized."

	^ #(( $@	#parseAnchor )
		( $!!		#parseHeader )
		( $#	#parseList )
		( $-		#parseList )
		( $|		#parseTable )
		( $_		#parseRule )
		( $=		#parsePreformatted )
		( Character cr #parseBlank )
		( Character lf	#parseBlank )).! !

Object subclass: #PRMacroExpander
	instanceVariableNames: 'character table default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Utilities'!

PRMacroExpander class
	instanceVariableNames: 'Default'!

!PRMacroExpander class methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
default
	^ Default! !

!PRMacroExpander class methodsFor: 'class initialization' stamp: 'lr 12/1/2005 20:12'!
initialize
	Default := self on: (Dictionary new
		at: $c put: [ :char :context | context command name ];		" current command "
		at: $r put: [ :char :context | context kernel root title ];		" current root structure "
		at: $t put: [ :char :context | context structure title ];			" current structure "
		at: $k put: [ :char :context | context kernel name ];			" current kernel name "
		yourself).! !

!PRMacroExpander class methodsFor: 'instance creation' stamp: 'lr 4/17/2005 11:59'!
on: aDictionary
	^ self new
		table: aDictionary;
		yourself.! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
character
	^ character! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
character: aCharacter
	character := aCharacter! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
default
	^ default! !

!PRMacroExpander methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 11:58'!
defaultCharacter
	^ $%! !

!PRMacroExpander methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 11:58'!
defaultDefault
	^ [ :char | 
		self character = char
			ifTrue: [ String with: self character ]
			ifFalse: [ String with: self character with: char ] ].! !

!PRMacroExpander methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 11:58'!
defaultTable
	^ Dictionary new! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
default: aBlock
	default := aBlock! !

!PRMacroExpander methodsFor: 'private' stamp: 'lr 4/17/2005 11:58'!
expand: aReadStream using: anArray
	^ String streamContents: [ :writeStream |
		[ aReadStream atEnd ] whileFalse: [
			writeStream nextPutAll: (aReadStream upTo: self character).
			aReadStream atEnd ifFalse: [ 
				self 
					expand: aReadStream 
					using: anArray 
					to: writeStream ] ] ].! !

!PRMacroExpander methodsFor: 'private' stamp: 'lr 4/17/2005 11:58'!
expand: aReadStream using: anArray to: aWriteStream
	| char block |
	block := self table 
		at: (char := aReadStream next)
		ifAbsent: [ self default ].
	^ aWriteStream nextPutAll: (block 
		valueWithPossibleArgs: (anArray
			copyWithFirst: char)).! !

!PRMacroExpander methodsFor: 'initialization' stamp: 'lr 4/17/2005 11:58'!
initialize
	super initialize.
	self table: self defaultTable.
	self character: self defaultCharacter.
	self default: self defaultDefault.! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
table
	^ table! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
table: aDictionary
	table := aDictionary! !

!PRMacroExpander methodsFor: 'evaluation' stamp: 'lr 4/17/2005 11:58'!
value: aString
	^ self value: aString withArguments: Array new.! !

!PRMacroExpander methodsFor: 'evaluation' stamp: 'lr 4/17/2005 11:58'!
value: aString value: anObject
	^ self value: aString withArguments: (Array with: anObject).! !

!PRMacroExpander methodsFor: 'evaluation' stamp: 'lr 4/17/2005 11:58'!
value: aString withArguments: anArray
	^ self expand: aString readStream using: anArray.! !

Object subclass: #PRObject
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Core'!

PRObject subclass: #PRCommand
	instanceVariableNames: 'context answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRCommand commentStamp: '<historical>' prior: 0!
I am an abstract superclass of the command pattern in Pier. All modifications to the model have to be done through subclasses of myself, else they do not get propperly logged with the persistency mechanisme. I hold the context in which the receiver is executed in the instance-variable context. To modify the resulting context, create a copy of the current context and store it in the instance-variable answer.

The following event-handlers are called when executing an action in the given order. Do override these messages to customize the command, never override the other internal methods:
- Override the message #doInitialize to setup the internal state of the command, e.g. the default parameters and the properties from the current context.
- Override the message #doValidate to check the valid setup of the command and to raise exceptions in case any precondition isn't met. Speak here or forever rest in peace!! Don't change the model in there.
- Override the message #doExecute to execute the actual command. Do not raise exceptions in there, catch all the problems in #doValidate.
- Override the message #doPersistency to save the command that has been just executed with the current persistency strategy. Most commands don't need to override this message and just stick with the default behavior.
- Override the message #doAnswer to create the answer context. Most commands don't need to override this message and just stick with the default behavior.

Do not play with funny jumpy things, such as reusumeable exceptions or continuatins, inside the code of the command hierarchy, you will very likely run into severe problems.!

PRCommand subclass: #PRAddCommand
	instanceVariableNames: 'name type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRAddCommand commentStamp: '<historical>' prior: 0!
I'm a command used to add new structures to your structures. My code is very interesting if you want to understand how Pier is designed.

Type is the class (subclass of PRStructure) for which a new instance will be created.!

!PRAddCommand class methodsFor: 'accessing-description' stamp: 'lr 2/13/2006 16:41'!
descriptionName
	^ (MAStringDescription selector: #name label: 'Name' priority: 100)
		addCondition: [ :value | value allSatisfy: #isAlphaNumeric ] asCondition labelled: 'Please do only use letters and numbers.';
		beRequired;
		yourself.! !

!PRAddCommand class methodsFor: 'accessing-description' stamp: 'lr 12/23/2005 14:09'!
descriptionType
	^ (MASingleOptionDescription selector: #type label: 'Type' priority: 110 default: PRPage)
		options: (MADynamicObject on: [ self structureClasses ]);
		reference: MAClassDescription new;
		beRequired;
		beSorted;
		yourself.! !

!PRAddCommand class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false! !

!PRAddCommand class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:48'!
label
	^ 'Add'! !

!PRAddCommand class methodsFor: 'private' stamp: 'lr 12/23/2005 14:24'!
structureClasses
	^ PRCurrentContext value in: [ :context |
		PRStructure withAllConcreteClasses select: [ :each |
			(context structure class canBeParentOf: each)
				and: [ each canBeChildOf: context structure class ] ] ].! !

!PRAddCommand methodsFor: 'private' stamp: 'lr 2/13/2006 13:52'!
child
	"Create a new structure of class species, a subclass of PRStructure."
	
	^ self type named: self name.! !

!PRAddCommand methodsFor: 'events' stamp: 'lr 12/20/2005 23:27'!
doExecute
	"Create a new structure of requested type and add it to the children list of the current structure. If possible the following context will be set to an editor or a view onto the new structure."
	
	| structure |
	super doExecute.
	self structure childrenDecoration
		add: (structure := self child).
	self answer: (self context 
		structure: structure 
		command: (structure editCommandClass notNil
			ifTrue: [ structure editCommandClass ]
			ifFalse: [ structure viewCommandClass ]) 
				new).! !

!PRAddCommand methodsFor: 'events' stamp: 'lr 8/29/2005 10:41'!
doValidate
	"Verify that the new structure can be added before launching #doExecute. Basically, the title must be unique."
	
	super doValidate.
	self validateChild: self child in: self structure.! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 2/13/2006 16:10'!
name
	^ name ifNil: [ name := self uniqueName: 'untitled' in: self structure ].! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 2/13/2006 13:49'!
name: aString
	name := aString! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 2/13/2006 16:10'!
type
	^ type ifNil: [ type := PRPage ].! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 12/5/2005 16:52'!
type: aClass
	type := aClass! !

!PRCommand class methodsFor: 'instance creation' stamp: 'lr 12/21/2005 23:23'!
context: aContext
	(self isValidIn: aContext) 
		ifFalse: [ self error: self name , ' is not useable in the given context.' ].
	^ self new
		setContext: aContext;
		yourself.! !

!PRCommand class methodsFor: 'testing' stamp: 'lr 12/22/2005 00:00'!
isValidIn: aContext
	"Verify that a command as a meaning for the context aContext. Override this command to add new constraints that are static to the command."
	
	^ aContext structure isValidCommand: self in: aContext.! !

!PRCommand class methodsFor: 'accessing' stamp: 'lr 12/21/2005 00:03'!
shortLabel
	^ self label.! !

!PRCommand class methodsFor: 'accessing' stamp: 'lr 12/21/2005 23:05'!
structureClass
	^ PRStructure! !

!PRCommand methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:57'!
answer
	"Return a new context that should be activated after executing this action."
	
	^ answer! !

!PRCommand methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:57'!
answer: aContext
	"Set the resulting context of this command."
	
	answer := aContext! !

!PRCommand methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:57'!
context
	"Return the current context of the receiver."
	
	^ context! !

!PRCommand methodsFor: 'accessing' stamp: 'lr 1/19/2006 09:33'!
context: aContext
	"Set the current context of the receiver."
	
	context := aContext! !

!PRCommand methodsFor: 'events' stamp: 'lr 10/21/2005 17:46'!
doAnswer
	"Override the message #doAnswer to create the answer context. Most commands don't need to override this message and just stick with the default behavior."
	
	self answer isNil 
		ifTrue: [ self answer: (self context structure: self structure) ].! !

!PRCommand methodsFor: 'events' stamp: 'lr 8/29/2005 10:48'!
doExecute
	"Override the message #doExecute to execute the actual command. Do not raise exceptions in there, catch all the problems in #doValidate."! !

!PRCommand methodsFor: 'events' stamp: 'lr 8/29/2005 10:49'!
doInitialize
	"Override the message #doInitialize to setup the internal state of the command, e.g. the default parameters and the properties from the current context."! !

!PRCommand methodsFor: 'events' stamp: 'lr 1/23/2006 09:20'!
doPersistency
	"Override the message #doPersistency to save the command-context that has been just executed with the current persistency strategy. Most commands don't need to override this message and just stick with the default behavior."

	self context setTimestamp: TimeStamp now.
	self kernel persistency log: self context.! !

!PRCommand methodsFor: 'events' stamp: 'lr 10/21/2005 13:58'!
doValidate
	"Override the message #doValidate to check the valid setup of the command and to raise exceptions in case any precondition isn't met. Speak here or forever rest in peace!! Don't change the model in there."! !

!PRCommand methodsFor: 'actions' stamp: 'lr 1/14/2006 17:07'!
execute
	"Execute the command of the receiver. To implement your action in one of my sublcasses code, do NEVER OVERRIDE this message, but instead have a look at the different template methods (#doValidate, #doExecute, #doPersistency, #doAnswer) available in the events protocol."

	self isView
		ifTrue: [ self shouldNotImplement ].
	self kernel critical: [ 
		self doValidate; doExecute.
		self isLogged
			ifTrue: [ self doPersistency ] ].
	self doAnswer.! !

!PRCommand methodsFor: 'testing' stamp: 'lr 1/19/2006 08:59'!
isEdit
	^ false! !

!PRCommand methodsFor: 'testing' stamp: 'lr 11/20/2005 19:32'!
isLogged
	"Most comands are logged, this means they do modify the model and are therefor preserved in the history. However there are some that just display something or change the state of the current context and neither change the model nor need to be logged."

	^ true! !

!PRCommand methodsFor: 'testing' stamp: 'lr 12/20/2005 12:12'!
isQuick
	"Quick commands do not have a configuration-inteface (probably not even Magritte descriptions) and therefor should not be presented to the user but simply executed."

	^ false! !

!PRCommand methodsFor: 'testing' stamp: 'lr 11/20/2005 19:31'!
isView
	"Most comands are not a view, this means they override #doExecute to do something meaningful on the context or the model."

	^ false! !

!PRCommand methodsFor: 'accessing-delegated' stamp: 'lr 4/17/2005 11:57'!
kernel
	^ self context kernel.! !

!PRCommand methodsFor: 'accessing-delegated' stamp: 'lr 12/1/2005 20:12'!
name
	^ self class label.! !

!PRCommand methodsFor: 'accessing-delegated' stamp: 'lr 4/17/2005 11:57'!
root
	^ self context kernel root.! !

!PRCommand methodsFor: 'initialization' stamp: 'lr 9/25/2005 15:23'!
setContext: aContext
	context := aContext.
	self doInitialize.! !

!PRCommand methodsFor: 'accessing-delegated' stamp: 'lr 4/17/2005 11:57'!
structure
	^ self context structure.! !

!PRCommand methodsFor: 'accessing-properties' stamp: 'lr 10/21/2005 15:51'!
timestamp
	^ self propertyAt: #timestamp ifAbsent: [ nil ].! !

!PRCommand methodsFor: 'accessing-properties' stamp: 'lr 10/21/2005 15:51'!
timestamp: aTimestamp
	self propertyAt: #timestamp put: aTimestamp.! !

!PRCommand methodsFor: 'private' stamp: 'lr 2/13/2006 15:35'!
uniqueName: aString in: aStructure
	"Answer an unique structure name with the prefix aString within the parent aStructure."

	| index name |
	(aStructure notNil 
		and: [ aStructure hasChildren ]
		and: [ aStructure childrenDecoration includes: aString ]) 
			ifFalse: [ ^ aString ].
	index := 1.
	[ aStructure childrenDecoration 
		includes: (name := aString , ' ' , (index := index + 1) asString) ]
		whileTrue.
	^ name.! !

!PRCommand methodsFor: 'validating' stamp: 'lr 2/13/2006 16:06'!
validateChild: aChildStructure in: aStructure
	"Make sure that aChildStructure can be added as child or replace an existing child in a aStructure."

	self validateChild: aChildStructure named: aChildStructure name in: aStructure.! !

!PRCommand methodsFor: 'validating' stamp: 'lr 2/13/2006 16:07'!
validateChild: aChildStructure named: aString in: aStructure
	self validateName: aString of: aChildStructure in: aStructure.
	self validateNestingOf: aChildStructure in: aStructure.! !

!PRCommand methodsFor: 'validating' stamp: 'lr 2/13/2006 16:09'!
validateName: aString of: aChildStructure in: aStructure
	"Make sure that aChildStructure with the title aString can be added as child or replace an existing child in a aStructure."

	| child |
	aStructure isNil 
		ifTrue: [ ^ self ].
 	aStructure hasChildren
		ifFalse: [ ^ self ].
	child := aStructure childrenDecoration
		at: aString 
		ifAbsent: [ ^ self ].
	child ~= aChildStructure
		ifTrue: [ PRConflictingNameError in: aStructure title: aString ].! !

!PRCommand methodsFor: 'validating' stamp: 'lr 1/3/2006 10:50'!
validateNestingOf: aChildStructure in: aStructure
	"Make sure that aChildStructure can be added as child to aStructure and that aStructure can have aChildStructure as a child."

	aStructure isNil
		ifTrue: [ ^ self ].
	(aStructure canBeParentOf: aChildStructure)
		ifFalse: [ PRInvalidNestingError of: aChildStructure in: aStructure ].
	(aChildStructure canBeChildOf: aStructure)
		ifFalse: [ PRInvalidNestingError of: aChildStructure in: aStructure ].	! !

PRCommand subclass: #PREditCommand
	instanceVariableNames: 'fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PREditCommand commentStamp: 'lr 8/29/2005 10:55' prior: 0!
Abstract command to edit structures.!

!PREditCommand class methodsFor: 'testing' stamp: 'lr 2/13/2006 17:30'!
isAbstract
	^ false! !

!PREditCommand class methodsFor: 'accessing' stamp: 'lr 2/13/2006 17:29'!
label
	^ 'Edit'! !

!PREditCommand methodsFor: 'accessing' stamp: 'lr 2/13/2006 17:19'!
description
	^ self structure description select: [ :each | each hasProperty: #editable ]. ! !

!PREditCommand methodsFor: 'events' stamp: 'lr 2/13/2006 17:28'!
doExecute
	super doExecute.
	self fields keysAndValuesDo: [ :desc :value | self structure write: value using: desc ].! !

!PREditCommand methodsFor: 'accessing' stamp: 'lr 2/13/2006 17:18'!
fields
	^ fields ifNil: [ fields := Dictionary new ].! !

!PREditCommand methodsFor: 'testing' stamp: 'lr 1/19/2006 08:59'!
isEdit
	^ true! !

!PREditCommand methodsFor: 'private' stamp: 'lr 2/13/2006 17:26'!
readUsing: aDescription
	^ (self description includes: aDescription)
		ifFalse: [ super readUsing: aDescription ]
		ifTrue: [ 
			self fields 
				at: aDescription
				ifAbsent: [ self structure readUsing: aDescription ] ].! !

!PREditCommand methodsFor: 'private' stamp: 'lr 2/13/2006 17:27'!
write: anObject using: aDescription
	^ (self description includes: aDescription)
		ifFalse: [ super write: anObject using: aDescription ]
		ifTrue: [ self fields at: aDescription put: anObject ].! !

PRCommand subclass: #PRLocationCommand
	instanceVariableNames: 'name target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

PRLocationCommand subclass: #PRCopyCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRCopyCommand class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false! !

!PRCopyCommand class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:48'!
label
	^ 'Copy'! !

!PRCopyCommand methodsFor: 'accessing-defaults' stamp: 'lr 2/13/2006 16:31'!
defaultName
	^ self uniqueName: self structure name , ' copy' in: self target.! !

!PRCopyCommand methodsFor: 'events' stamp: 'lr 2/13/2006 16:20'!
doExecute
	| structure |
	super doExecute.
	structure := self target childrenDecoration 
		add: (self structure copy
			name: self name;
			yourself).
	PRReferences
		from: structure
		to: (structure enumerator
			with; all; hidden;
			contents)
		do: [ :each | each update ].
	self answer: (self context
		structure: structure).! !

!PRLocationCommand class methodsFor: 'accessing-description' stamp: 'lr 2/13/2006 16:28'!
descriptionName
	^ (MAStringDescription selector: #name label: 'Name' priority: 110)
		beRequired;
		yourself.! !

!PRLocationCommand class methodsFor: 'accessing-description' stamp: 'lr 2/13/2006 16:28'!
descriptionTarget
	^ (PRStructureDescription selector: #target label: 'Target' priority: 100)
		beRequired;
		yourself.! !

!PRLocationCommand methodsFor: 'accessing-defaults' stamp: 'lr 2/13/2006 16:27'!
defaultName
	^ self structure name.! !

!PRLocationCommand methodsFor: 'accessing-defaults' stamp: 'lr 2/13/2006 16:27'!
defaultTarget
	^ self structure parent.! !

!PRLocationCommand methodsFor: 'events' stamp: 'lr 2/13/2006 16:29'!
doValidate
	super doValidate.
	self validateChild: self structure named: self name in: self target.! !

!PRLocationCommand methodsFor: 'accessing' stamp: 'lr 2/13/2006 16:26'!
name
	^ name ifNil: [ name := self defaultName ].! !

!PRLocationCommand methodsFor: 'accessing' stamp: 'lr 2/13/2006 16:27'!
name: aString
	name := aString! !

!PRLocationCommand methodsFor: 'accessing' stamp: 'lr 2/13/2006 16:26'!
target
	^ target ifNil: [ target := self defaultTarget ].! !

!PRLocationCommand methodsFor: 'accessing' stamp: 'lr 2/13/2006 16:27'!
target: aStructure
	target := aStructure! !

PRLocationCommand subclass: #PRMoveCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRMoveCommand class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false! !

!PRMoveCommand class methodsFor: 'testing' stamp: 'lr 12/21/2005 23:55'!
isValidIn: aContext
	^ (super isValidIn: aContext) 
		and: [ aContext structure isRoot not ].! !

!PRMoveCommand class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:48'!
label
	^ 'Move'! !

!PRMoveCommand methodsFor: 'events' stamp: 'lr 2/13/2006 16:15'!
doExecute
	super doExecute.
	self structure name: self name.
	self target childrenDecoration 
		add: self structure remove.
	PRReferences
		from: self kernel root
		to: (self structure enumerator
			with; all; hidden;
			contents)
		do: [ :each | each update ].! !

!PRMoveCommand methodsFor: 'events' stamp: 'lr 2/13/2006 16:29'!
doValidate
	super doValidate.
	(self structure isAncestorOf: self target)
		ifTrue: [ PRInvalidNestingError of: self structure in: self target ].! !

PRCommand subclass: #PRRemoveCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRRemoveCommand class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false! !

!PRRemoveCommand class methodsFor: 'testing' stamp: 'lr 1/3/2006 10:54'!
isValidIn: aContext
	^ (super isValidIn: aContext) 
		and: [ aContext structure isRoot not ].! !

!PRRemoveCommand class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:48'!
label
	^ 'Remove'! !

!PRRemoveCommand methodsFor: 'events' stamp: 'lr 1/14/2006 17:03'!
doExecute
	super doExecute.
	PRReferences
		from: self kernel root
		to: (self structure enumerator
			with; all; hidden;
			contents)
		do: [ :each | each target: nil ].
	self structure parent in: [ :parent |
		self structure remove.
		self answer: (self context 
			structure: parent) ].! !

!PRRemoveCommand methodsFor: 'events' stamp: 'lr 1/5/2006 20:37'!
doValidate
	super doValidate.
	self structure isRoot
		ifTrue: [ self error: 'Unable to remove root node.' ].! !

!PRRemoveCommand methodsFor: 'testing' stamp: 'lr 12/23/2005 15:04'!
isQuick
	^ true! !

PRCommand subclass: #PRViewCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRViewCommand class methodsFor: 'testing' stamp: 'lr 4/17/2005 12:00'!
isAbstract
	^ false! !

!PRViewCommand class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:48'!
label
	^ 'View'! !

!PRViewCommand methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isLogged
	^ false! !

!PRViewCommand methodsFor: 'testing' stamp: 'lr 4/26/2005 21:47'!
isView
	^ true! !

PRObject subclass: #PRContext
	instanceVariableNames: 'kernel structure command timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Kernel'!

!PRContext commentStamp: '<historical>' prior: 0!
I am the context in which a user is browsing the wiki. I hold all the information any part of SmallWiki might be interested in: the kernel of the wiki, the structure that is currently displayed, the command that is being executed and the user currently logged in.

I am an imutable object, users should never try to modify me. Instead use the modification methods that return a copy of myself.!

!PRContext class methodsFor: 'accessing-description' stamp: 'lr 1/19/2006 10:31'!
descriptionCommand
	^ (MAToOneRelationDescription accessor: (MASelectorAccessor read: #command write: #setCommand:) label: 'Command' priority: 20)
		classes: (MADynamicObject on: [ PRCommand withAllConcreteClasses ]);
		reference: PRCommand description;
		yourself.! !

!PRContext class methodsFor: 'accessing-description' stamp: 'lr 1/19/2006 10:31'!
descriptionStructure
	^ PRStructureDescription accessor: (MASelectorAccessor read: #structure write: #setStructure:) label: 'Structure' priority: 10.! !

!PRContext class methodsFor: 'accessing-description' stamp: 'lr 1/19/2006 09:40'!
descriptionTimestamp
	^ MATimeStampDescription accessor: (MASelectorAccessor read: #timestamp write: #setTimestamp:) label: 'Timestamp'.! !

!PRContext class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false! !

!PRContext class methodsFor: 'instance creation' stamp: 'lr 4/17/2005 11:59'!
kernel: aKernel
	^ self kernel: aKernel structure: aKernel root.! !

!PRContext class methodsFor: 'instance creation' stamp: 'lr 12/20/2005 23:19'!
kernel: aKernel structure: aStructure
	^ self kernel: aKernel structure: aStructure command: aStructure viewCommandClass new.! !

!PRContext class methodsFor: 'instance creation' stamp: 'lr 9/9/2005 09:32'!
kernel: aKernel structure: aStructure command: aCommand
	^ self new
		setKernel: aKernel;
		setStructure: aStructure;
		setCommand: aCommand;
		yourself.! !

!PRContext methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
command
	^ command! !

!PRContext methodsFor: 'accessing-conveniance' stamp: 'lr 12/21/2005 23:56'!
commands
	"Answer a list of possible commands, dispatching trough the command class."

	^ PRCommand withAllConcreteClasses
		select: [ :each | each isValidIn: self ].! !

!PRContext methodsFor: 'navigation' stamp: 'lr 12/20/2005 22:42'!
command: aCommand
	"Create a copy of the current context with the current command replaced by aCommand."

	^ self structure: self structure command: aCommand.! !

!PRContext methodsFor: 'testing' stamp: 'lr 12/21/2005 23:02'!
isValid
	"Answer true if the receiver is a valid context."

	^ self isValidCommand: self command class.! !

!PRContext methodsFor: 'testing' stamp: 'lr 12/22/2005 00:00'!
isValidCommand: aCommandClass
	"Answer true if the receiver is a valid context with the current command replaced by aCommandClass."

	^ aCommandClass isValidIn: self.! !

!PRContext methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
kernel
	^ kernel! !

!PRContext methodsFor: 'accessing-conveniance' stamp: 'lr 12/21/2005 23:55'!
root
	"Answer the current root node of the structure-tree."

	^ self kernel root.! !

!PRContext methodsFor: 'initialization' stamp: 'lr 12/21/2005 22:43'!
setCommand: aCommand
	command := aCommand.
	command setContext: self.! !

!PRContext methodsFor: 'initialization' stamp: 'lr 4/17/2005 11:58'!
setKernel: aKernel
	kernel := aKernel! !

!PRContext methodsFor: 'initialization' stamp: 'lr 4/17/2005 11:58'!
setStructure: aStructure
	structure := aStructure! !

!PRContext methodsFor: 'initialization' stamp: 'lr 1/19/2006 09:57'!
setTimestamp: aTimestamp
	timestamp := aTimestamp.! !

!PRContext methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
structure
	^ structure! !

!PRContext methodsFor: 'navigation' stamp: 'lr 12/20/2005 23:18'!
structure: aStructure
	"Create a copy of the current context with the current structure replaced by aStructure and the current command replaced by the default view."

	^ self structure: aStructure command: aStructure viewCommandClass new.! !

!PRContext methodsFor: 'navigation' stamp: 'lr 10/21/2005 16:35'!
structure: aStructure command: aCommand
	"Create a copy of the current context with the current structure replaced by aStructure and the current command by aCommand."

	^ self copy
		setStructure: aStructure;
		setCommand: aCommand;
		yourself.! !

!PRContext methodsFor: 'accessing-conveniance' stamp: 'lr 1/19/2006 09:57'!
timestamp
	"Answer the timestamp when this context was used to execute its command, nil if never executed."

	^ timestamp! !

PRObject subclass: #PRDecorated
	instanceVariableNames: 'decorations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRDecorated methodsFor: 'visiting' stamp: 'lr 10/20/2005 15:53'!
acceptDecorated: aVisitor
	self
		decorationsDo: [ :each | aVisitor visit: each ]
		ownerDo: [ :each | super acceptDecorated: aVisitor ].! !

!PRDecorated methodsFor: 'visiting' stamp: 'lr 10/20/2005 15:54'!
accept: aVisitor
	aVisitor visitDecorated: self.! !

!PRDecorated methodsFor: 'adding' stamp: 'lr 10/20/2005 15:49'!
addDecoration: aDecoration
	"Add aDecoration to the receiver. This message ensures that aDecoration is only added once and that the decorations remain properly sorted."

	^ self 
		addDecoration: aDecoration 
		ifPresent: [ :value | self error: 'Decoration is already part of receiver.' ].! !

!PRDecorated methodsFor: 'adding' stamp: 'lr 12/20/2005 09:55'!
addDecoration: aDecoration ifPresent: aBlock
	"Add aDecoration to the receiver. This message ensures that the decorations remain properly sorted and that there are no duplicates. In case aDecoration is already within the receiver, the existing decoration is passed into aBlock."

	| decoration |
	decoration := self decorations
		detect: [ :each | aDecoration = each ]
		ifNone: [ nil ].
	^ decoration isNil
		ifFalse: [ aBlock value: decoration ]
		ifTrue: [
			self setDecorations: (decorations 
				copyWith: (aDecoration
					setDecorated: self;
					yourself)) sort.
			aDecoration ].! !

!PRDecorated methodsFor: 'querying' stamp: 'lr 10/20/2005 16:45'!
decorationOfClass: aClass
	^ self
		decorationOfClass: aClass 
		ifAbsent: [ self error: 'Decoration not found.' ].! !

!PRDecorated methodsFor: 'querying' stamp: 'lr 10/20/2005 16:12'!
decorationOfClass: aClass ifAbsent: aBlock
	^ self decorations
		detect: [ :each | aClass = each species ]
		ifNone: aBlock.! !

!PRDecorated methodsFor: 'accessing' stamp: 'lr 10/20/2005 15:50'!
decorations
	^ decorations! !

!PRDecorated methodsFor: 'enummeration' stamp: 'lr 10/20/2005 15:57'!
decorationsDo: aBlock
	self decorations do: aBlock.! !

!PRDecorated methodsFor: 'enummeration' stamp: 'lr 12/20/2005 18:30'!
decorationsDo: aBlock ownerDo: anOwnerBlock
	self decorations do: [ :each |
		each priority negative
			ifTrue: [ aBlock value: each ] ].
	anOwnerBlock value: self.
	self decorations do: [ :each |
		each priority positive
			ifTrue: [ aBlock value: each ] ].! !

!PRDecorated methodsFor: 'initialization' stamp: 'lr 2/13/2006 15:04'!
initialize
	super initialize.
	self setDecorations: #().! !

!PRDecorated methodsFor: 'copying' stamp: 'lr 12/20/2005 18:29'!
postCopy
	super postCopy.
	self setDecorations: (self decorations collect: [ :each | 
		each copy postCopyTo: self ]).! !

!PRDecorated methodsFor: 'removing' stamp: 'lr 10/20/2005 15:49'!
removeDecoration: aDecoration
	"Remove aDecoration from the receiver, an error is raised if aDecoration is not part of the receiver."

	^ self 
		removeDecoration: aDecoration 
		ifAbsent: [ self error: 'Decoration is not part of receiver.' ].! !

!PRDecorated methodsFor: 'removing' stamp: 'lr 12/20/2005 09:55'!
removeDecoration: aDecoration ifAbsent: aBlock
	"Remove aDecoration from the receiver, aBlock is evaluated if aDecoration is not part of the receiver."

	| decoration |
	decoration := self decorations
		detect: [ :each | aDecoration = each ]
		ifNone: [ ^ aBlock value ].
	self setDecorations: (self decorations
		copyWithout: (decoration
			setDecorated: nil;
			yourself)).
	^ decoration.! !

!PRDecorated methodsFor: 'initialization' stamp: 'lr 10/20/2005 15:56'!
setDecorations: anArray
	decorations := anArray! !

PRDecorated subclass: #PRStructure
	instanceVariableNames: 'parent name title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

PRStructure subclass: #PRFile
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRFile class methodsFor: 'accessing-description' stamp: 'lr 2/13/2006 17:25'!
descriptionFile
	^ (MAFileDescription selector: #file label: 'File' priority: 200)
		propertyAt: #editable put: true;
		yourself.! !

!PRFile class methodsFor: 'accessing-resources' stamp: 'lr 11/20/2005 20:10'!
icon
	"PRCompatibility compileFileNamed: 'icons/file.png' into: PRFile class selector: #icon"

	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 1 199 73 68 65 84 120 218 98 252 255 255 63 3 8 92 188 248 0 194 192 1 206 156 185 206 176 248 165 59 227 249 217 54 12 92 18 26 12 207 143 207 3 139 3 4 16 11 178 34 125 125 5 56 251 215 175 255 12 127 254 252 99 248 242 229 27 3 19 19 19 212 148 157 255 15 220 63 198 40 97 22 3 87 7 16 64 44 184 108 100 102 102 100 248 255 159 9 72 51 49 64 29 201 96 110 174 205 48 119 238 246 255 140 140 255 24 97 234 0 2 136 9 151 1 11 22 108 103 96 100 100 0 27 0 243 194 201 147 87 193 236 150 180 88 184 119 1 2 8 171 11 128 182 192 217 16 231 255 99 240 242 178 98 248 248 241 43 195 167 79 95 25 46 95 190 3 151 7 8 32 172 46 72 78 246 132 123 131 17 232 12 16 253 229 203 119 134 239 223 127 128 217 200 0 32 128 152 240 185 0 230 141 191 127 255 51 252 254 253 151 129 133 133 25 136 81 29 13 16 64 88 189 144 148 228 9 212 0 137 133 79 159 190 48 252 252 249 135 129 157 157 21 24 152 44 64 195 254 161 168 5 8 32 12 3 64 33 14 194 32 91 127 254 252 9 102 179 178 50 131 229 254 253 251 15 246 18 50 0 8 32 12 47 128 228 255 252 249 207 176 108 217 78 136 13 64 103 131 98 98 207 158 83 96 26 196 71 6 0 1 132 97 192 63 160 11 23 47 222 193 16 26 234 196 176 110 221 65 176 141 91 182 28 133 7 42 58 0 8 32 12 3 254 254 197 12 19 63 63 91 168 235 24 49 188 0 16 64 24 6 128 66 59 60 220 153 97 245 234 125 12 33 33 142 96 91 55 109 58 12 150 219 190 253 56 134 225 0 1 196 130 233 133 191 224 128 3 105 6 101 52 80 192 129 92 240 231 207 95 48 31 20 51 200 0 32 128 152 176 57 31 228 74 152 83 97 249 128 145 17 123 146 7 8 32 22 228 236 10 194 164 2 128 0 3 0 237 195 170 115 175 167 116 71 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray.! !

!PRFile class methodsFor: 'testing' stamp: 'lr 11/20/2005 19:40'!
isAbstract
	^ false! !

!PRFile methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitFile: self.! !

!PRFile methodsFor: 'accessing-dynamic' stamp: 'lr 8/10/2005 20:04'!
contents
	^ self file contents.! !

!PRFile methodsFor: 'accessing-configuration' stamp: 'lr 8/10/2005 20:05'!
defaultFile
	^ MAFileModel new.! !

!PRFile methodsFor: 'accessing' stamp: 'lr 8/10/2005 20:03'!
file
	^ file! !

!PRFile methodsFor: 'accessing-dynamic' stamp: 'lr 8/10/2005 20:04'!
filename
	^ self file filename.! !

!PRFile methodsFor: 'accessing' stamp: 'lr 8/10/2005 20:03'!
file: aFile
	file := aFile! !

!PRFile methodsFor: 'initialization' stamp: 'lr 8/10/2005 20:05'!
initialize
	super initialize.
	self file: self defaultFile.! !

!PRFile methodsFor: 'accessing-dynamic' stamp: 'lr 8/10/2005 20:04'!
mimetype
	^ self file mimetype.! !

!PRFile methodsFor: 'copying' stamp: 'lr 8/25/2005 17:00'!
postCopy
	super postCopy.
	self file: self file copy.! !

PRStructure subclass: #PRPage
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRPage class methodsFor: 'accessing-description' stamp: 'lr 2/13/2006 17:25'!
descriptionContents
	^ (MAMemoDescription selector: #contents label: 'Contents' priority: 200)
		propertyAt: #editable put: true;
		yourself.! !

!PRPage class methodsFor: 'accessing-resources' stamp: 'lr 11/20/2005 20:10'!
icon
	"PRCompatibility compileFileNamed: 'icons/page.png' into: PRPage class selector: #icon"

	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 1 211 73 68 65 84 120 218 98 252 255 255 63 3 8 92 188 248 0 194 192 1 206 156 185 206 176 248 165 59 227 249 217 54 12 92 18 26 12 207 143 207 3 139 3 4 16 11 178 34 125 125 5 56 251 215 175 255 12 127 254 252 99 248 242 229 27 3 19 19 19 212 148 157 255 15 220 63 198 40 97 22 3 87 7 16 64 44 184 108 100 102 102 100 248 255 159 9 72 51 49 64 29 201 96 110 174 205 48 119 238 246 255 140 140 255 24 97 234 0 2 8 195 128 221 187 207 130 233 191 127 25 24 254 253 251 207 96 101 165 13 118 9 200 11 48 208 146 22 11 50 18 108 8 64 0 97 24 224 234 106 12 166 255 253 99 0 106 252 207 240 227 199 47 16 143 193 203 203 138 225 227 199 175 12 159 62 125 101 184 124 249 14 92 61 64 0 225 116 1 200 217 32 67 126 254 252 13 116 205 95 176 230 31 63 126 48 152 153 105 161 168 7 8 32 156 46 128 121 227 251 247 95 64 141 191 25 94 189 250 0 228 255 1 123 11 25 0 4 16 86 23 128 108 7 57 255 239 223 127 12 223 190 125 103 248 253 251 15 152 13 18 183 180 212 65 81 15 16 64 24 6 184 184 24 131 21 254 252 249 15 236 100 144 237 160 180 242 251 247 95 176 237 255 64 254 66 2 0 1 132 97 192 158 61 103 129 138 255 3 211 193 47 176 6 136 205 16 141 32 182 141 141 62 138 122 128 0 194 48 192 217 217 24 232 239 223 96 197 32 77 160 40 4 25 240 231 207 95 56 31 25 0 4 16 134 1 59 119 130 92 240 27 108 59 72 35 178 11 64 180 149 149 30 138 122 128 0 194 48 192 222 222 0 168 248 47 220 0 152 173 160 168 4 137 161 187 0 32 128 48 12 0 105 6 5 34 72 243 190 125 231 192 46 0 25 250 31 71 86 3 8 32 20 3 64 241 14 2 140 140 32 204 200 224 232 104 8 15 3 144 24 54 67 0 2 136 5 57 187 34 167 119 98 1 64 128 1 0 237 159 25 57 6 58 246 245 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray.! !

!PRPage class methodsFor: 'testing' stamp: 'lr 11/20/2005 19:40'!
isAbstract
	^ false! !

!PRPage methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitPage: self.! !

!PRPage methodsFor: 'accessing-dynamic' stamp: 'lr 12/22/2005 14:39'!
contents
	^ self rendererClass write: self document.! !

!PRPage methodsFor: 'accessing-dynamic' stamp: 'lr 4/17/2005 11:58'!
contents: aString
	self document: (self parserClass parse: aString).! !

!PRPage methodsFor: 'accessing-configuration' stamp: 'lr 11/17/2005 16:03'!
defaultDocument
	^ PRDocument new
		add: (PRParagraph new
			add: (PRText with: 'Edit this page ...');
			yourself);
		yourself.! !

!PRPage methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
document
	^ document! !

!PRPage methodsFor: 'accessing' stamp: 'lr 1/16/2006 11:37'!
document: aDocument
	document := aDocument.
	document owner: self.! !

!PRPage methodsFor: 'testing' stamp: 'lr 11/14/2005 09:43'!
hasDocument
	^ self document notNil.! !

!PRPage methodsFor: 'initialize-release' stamp: 'lr 4/17/2005 11:58'!
initialize
	super initialize.
	self document: self defaultDocument.! !

!PRPage methodsFor: 'accessing-configuration' stamp: 'lr 11/17/2005 16:03'!
parserClass
	^ PRDocumentParser! !

!PRPage methodsFor: 'copying' stamp: 'lr 4/17/2005 11:58'!
postCopy
	super postCopy.
	self document: self document copy.! !

!PRPage methodsFor: 'accessing-configuration' stamp: 'lr 11/17/2005 16:03'!
rendererClass
	^ PRDocumentWriter! !

!PRStructure class methodsFor: 'testing' stamp: 'lr 9/25/2005 18:41'!
canBeChildOf: aStructureClass
	^ true! !

!PRStructure class methodsFor: 'testing' stamp: 'lr 11/7/2005 20:46'!
canBeParentOf: aStructureClass
	^ true! !

!PRStructure class methodsFor: 'accessing-private' stamp: 'lr 2/13/2006 17:24'!
descriptionName
	^ (MAStringDescription selector: #name label: 'Name')
		beRequired;
		yourself.! !

!PRStructure class methodsFor: 'accessing-private' stamp: 'lr 11/17/2005 16:09'!
descriptionParent
	^ (PRStructureDescription selector: #parent label: 'Parent')
		beReadonly; 
		beHidden; 
		yourself.! !

!PRStructure class methodsFor: 'accessing-private' stamp: 'lr 11/17/2005 16:09'!
descriptionRoot
	^ (PRStructureDescription selector: #root label: 'Root')
		beReadonly; 
		beHidden; 
		yourself.! !

!PRStructure class methodsFor: 'accessing-description' stamp: 'lr 2/13/2006 17:24'!
descriptionTitle
	^ (MAStringDescription selector: #title label: 'Title' priority: 100)
		propertyAt: #editable put: true;
		beRequired;
		yourself.! !

!PRStructure class methodsFor: 'accessing-resources' stamp: 'lr 11/20/2005 20:09'!
icon
	"PRCompatibility compileFileNamed: 'icons/structure.png' into: PRStructure class selector: #icon"

	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 2 37 73 68 65 84 120 218 98 252 255 255 63 3 12 28 191 252 252 150 152 32 151 212 191 127 255 126 194 196 254 1 241 207 223 12 12 95 190 253 230 184 123 239 193 241 55 175 94 196 50 179 176 62 231 224 17 96 152 53 161 145 1 32 128 88 24 144 128 16 31 187 160 146 52 31 55 144 201 13 19 3 25 255 5 104 220 211 87 95 25 52 212 149 157 95 240 243 108 188 125 235 110 8 208 226 71 32 121 128 0 98 66 54 224 31 3 38 96 4 41 2 170 98 98 100 98 224 102 101 96 112 177 210 52 213 214 209 220 10 20 87 5 185 30 32 128 152 24 136 0 172 204 64 39 113 177 49 188 253 252 141 225 220 245 199 64 87 49 233 176 113 112 111 255 207 240 223 0 32 128 136 50 128 17 104 29 23 59 51 131 136 160 0 195 251 15 191 24 94 189 249 204 192 196 202 161 252 247 207 159 104 128 0 98 33 198 0 102 160 1 204 64 87 176 0 9 94 62 78 6 54 14 118 134 95 127 89 24 254 255 251 207 2 16 64 68 25 240 11 24 11 239 62 253 100 248 244 229 59 208 59 44 12 44 156 64 111 253 99 1 57 237 63 64 0 17 52 224 235 47 160 230 207 191 25 126 254 250 195 192 206 206 202 192 194 194 2 142 25 166 63 140 96 175 1 4 16 11 33 205 95 127 128 188 192 204 192 201 198 202 240 155 233 31 195 159 191 127 129 54 51 49 252 7 233 6 2 128 0 194 105 192 239 255 144 52 192 202 10 114 41 80 3 3 72 233 31 160 94 70 112 212 254 254 7 49 0 32 128 112 26 240 31 26 112 255 128 137 227 63 48 174 88 88 24 25 254 3 5 25 129 113 207 8 180 29 102 16 64 0 97 141 70 144 205 240 20 206 8 118 49 3 72 57 200 37 204 64 205 76 64 54 51 35 68 43 64 0 225 52 0 57 37 66 146 232 127 48 227 223 255 255 40 106 1 2 8 197 11 76 200 201 151 17 226 13 80 50 6 198 28 80 43 35 208 59 44 12 255 88 254 0 213 49 131 99 1 4 0 2 8 197 128 223 176 120 7 217 5 180 232 15 16 255 253 15 241 14 136 13 12 66 134 191 12 172 16 23 2 117 50 177 176 49 2 4 16 138 1 139 22 44 157 184 117 227 74 105 14 14 174 223 184 188 4 230 253 7 165 74 54 142 7 183 47 157 6 8 48 0 76 143 160 230 112 21 24 41 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray.! !

!PRStructure class methodsFor: 'instance-creation' stamp: 'lr 2/13/2006 13:53'!
named: aString
	^ self new
		name: aString;
		yourself.! !

!PRStructure methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitStructure: self.! !

!PRStructure methodsFor: 'accessing-children' stamp: 'lr 11/20/2005 21:34'!
addChild: aStructure
	"Add aStructure as child to the receiver."

	^ self childrenDecoration add: aStructure.! !

!PRStructure methodsFor: 'testing' stamp: 'lr 9/25/2005 18:40'!
canBeChildOf: aStructure
	^ self class canBeChildOf: aStructure class.! !

!PRStructure methodsFor: 'testing' stamp: 'lr 11/7/2005 20:46'!
canBeParentOf: aStructure
	^ self class canBeParentOf: aStructure class.! !

!PRStructure methodsFor: 'decorations' stamp: 'lr 10/20/2005 16:41'!
childrenDecoration
	^ self 
		decorationOfClass: self childrenDecorationClass 
		ifAbsent: [ self addDecoration: self childrenDecorationClass new ].! !

!PRStructure methodsFor: 'decorations' stamp: 'lr 12/20/2005 10:08'!
childrenDecorationClass
	^ PRChildren! !

!PRStructure methodsFor: 'accessing-persistency' stamp: 'lr 12/9/2005 12:01'!
creationTimestamp
	"Answer the creation-timestamp or nil."

	self kernel persistency 
		do: [ :each | ^ each timestamp ]
		for: self.
	^ nil.! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 11/17/2005 16:08'!
document
	^ PRDocument new
		add: (PRInternalLink new
			embedded: true; target: self;
			add: (PRText with: self title);
			yourself);
		yourself.! !

!PRStructure methodsFor: 'accessing-commands' stamp: 'lr 2/13/2006 17:43'!
editCommandClass
	"Answer an instance of the default edit command of the reciever."

	^ PREditCommand! !

!PRStructure methodsFor: 'accessing-children' stamp: 'lr 1/14/2006 16:10'!
enumerator
	"Answer an enumerator on the children of the receiver."

	^ PRChildrenVisitor on: self.! !

!PRStructure methodsFor: 'testing' stamp: 'lr 1/16/2006 11:19'!
hasChildren
	"Answer true if the receiver has got children, they might not be visible however."
	
	self enumerator hidden; do: [ :each | ^ true ].
	^ false.! !

!PRStructure methodsFor: 'testing' stamp: 'lr 11/14/2005 09:43'!
hasDocument
	^ false! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
hasParent
	"Answer true if the receiver has got a parent. This is the negation of #isRoot."
		
	^ self parent notNil.! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 11/20/2005 21:32'!
icon
	"Return the raw data of an icon representing the type of the receiver."

	^ self class icon.! !

!PRStructure methodsFor: 'testing' stamp: 'lr 2/10/2006 19:20'!
isAllowedCommand: aCommandClass in: aContext
 	"Answer true if the receiver accepts aCommandClass as allowed in aContext.

	Whether a aCommandClass is allowed or not is a only security question and should therefore only depend the permissions the current user has on the current structure. It should not depend on the kind of command or structure. Security decoritions are the responsible instances to decide whether aCommandClass is allowed. Therefore this message is delegated to them. This method should not be overridden by subclasses. Security decorations should override it instead."
	
	^ self decorations allSatisfy: [ :each | 
		each 
			isAllowedCommand: aCommandClass 
			in: aContext ].! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAncestorOf: aStructure
	"Answer true if the receiver is an ancestor of aStructure."
	
	^ aStructure parents includes: self.! !

!PRStructure methodsFor: 'testing' stamp: 'lr 2/10/2006 19:22'!
isApplyableCommand: aCommandClass in: aContext
 	"Answer true if the receiver accepts aCommandClass as aplyable in aContext.

	Whether a aCommandClass is aplyable or not is a question about saneness and compability, not about security. I.e aplying a PREditFileCommand on a PRStructure doesn't make sense even if the current user is administrator who has full power without restrictions because a PREditFileCommand is not compatible with a PRStructure. It is therefore not applyable.
	
	This method should be overriden by subclasses who want to forbid generic commands. I.e a structure that never must be removed, moved or copied."
	
	^ self isKindOf: aCommandClass structureClass.! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isRoot
	"Answer true if the receiver is the root of a wiki-tree. This is the negation of #hasParent."

	^ self parent isNil.! !

!PRStructure methodsFor: 'testing' stamp: 'lr 2/10/2006 19:22'!
isValidCommand: aCommandClass in: aContext
 	"Answer true if the receiver accepts to execute aCommandClass in aContext.

	Whether a aCommandClass is valid in a context depends on two questions. Whether it is applyable and wether it is allowed. See #isApplyableCommand:in: and #isAllowedCommand:in: for details. This method should not be overriden. They should either override #isApplyableCommand:in: or security decorations should override #isAllowedCommand:in:."
	
	^ (self isApplyableCommand: aCommandClass in: aContext)
		and: [ self isAllowedCommand: aCommandClass in: aContext ].! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 12/9/2005 11:50'!
kernel
	"Answer the kernel of the receiver."
	
	^ self root in: [ :root |
		PRKernel instances
			detect: [ :each | each root = root ]
			ifNone: [ self error: self title , ' is not part of a kernel.' ] ].! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 4/17/2005 11:59'!
level
	"Answer the nesting level of the reciever."
	
	^ self parents size.! !

!PRStructure methodsFor: 'accessing-persistency' stamp: 'lr 12/9/2005 12:04'!
modificationTimestamp
	"Answer the modification-timestamp or nil."

	self kernel persistency 
		reverseDo: [ :each | ^ each timestamp ]
		for: self.
	^ nil.! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 2/13/2006 17:14'!
name
	"Answer the name of the receiver. The name should be simple and only contain letters and numbers, since it is used as an identifier within restrictive protocols."

	^ name! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 2/13/2006 13:24'!
name: aString
	name := aString! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 2/13/2006 13:25'!
parent
	"Answer the parent structure of the receiver."

	^ parent! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 10/20/2005 17:14'!
parents
	"Answer an ordered collection of all the parents of the receiver up and including the reciever itself."

	^ self isRoot
		ifTrue: [ OrderedCollection with: self ]
		ifFalse: [
			self parent parents
				addLast: self;
				yourself ].! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
parent: aStructure
	parent := aStructure! !

!PRStructure methodsFor: 'copying' stamp: 'lr 10/20/2005 17:19'!
postCopy
	super postCopy.
	self parent: nil.! !

!PRStructure methodsFor: 'copying' stamp: 'lr 10/20/2005 15:51'!
postCopyTo: anObject
	self parent: anObject.! !

!PRStructure methodsFor: 'printing' stamp: 'lr 2/13/2006 14:50'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' name: '; print: self name.! !

!PRStructure methodsFor: 'actions' stamp: 'lr 9/5/2005 19:01'!
remove
	"Remove the reciever from the parent structure."

	self parent childrenDecoration remove: self.! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 4/17/2005 11:59'!
root
	"Answer the root structure of the receiver."
	
	^ self isRoot
		ifTrue: [ self ]
		ifFalse: [ self parent root ].! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 2/13/2006 17:32'!
title
	"Answer the title of the receiver, essentially the name but starting uppercase."

	^ title ifNil: [ title := self name capitalized ].! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 2/13/2006 17:15'!
title: aString
	title := aString! !

!PRStructure methodsFor: 'private' stamp: 'lr 2/13/2006 13:43'!
uniqueName
	| candidate |
	candidate := (self title select: #isAlphaNumeric) asLowercase.
	self hasParent ifTrue: [ 
		[ ]]! !

!PRStructure methodsFor: 'accessing-commands' stamp: 'lr 12/20/2005 23:18'!
viewCommandClass
	"Answer the default view command of the reciever. Most likely you never need to change the default implementation."

	^ PRViewCommand! !

PRObject subclass: #PRDecoration
	instanceVariableNames: 'decorated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRDecoration commentStamp: 'lr 1/9/2006 09:09' prior: 0!
A decoration is used to add new behaviour to structures. Every decoration knows its owner (decorated) and is can only added once. Decorations are considered to be equal if they are of the same class, but subclasses might want to refine this behaviour to be able to add multiple instances of the same class.

Within the owner decorations are ordered according to their priority. Decorations with a negative priority are visited before the owner, decorations with a positive one after the owner.!

PRDecoration subclass: #PRChildren
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRChildren class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false.! !

!PRChildren methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitChildren: self.! !

!PRChildren methodsFor: 'actions' stamp: 'lr 2/13/2006 13:43'!
add: aStructure
	(self isValidChild: aStructure)
		ifFalse: [ self error: 'Unable to add structure to ' , self decorated title , '.' ].
	self children
		at: aStructure name
		put: (aStructure 
			parent: self decorated;
			yourself).
	self triggerStructureAdded: aStructure.
	^ aStructure.! !

!PRChildren methodsFor: 'accessing-children' stamp: 'lr 11/5/2005 16:13'!
at: aString
	^ self at: aString ifAbsent: [ self error: 'Child not found.' ].! !

!PRChildren methodsFor: 'accessing-children' stamp: 'lr 10/20/2005 17:48'!
at: aString ifAbsent: aBlock
	^ self children at: aString ifAbsent: aBlock.! !

!PRChildren methodsFor: 'accessing-children' stamp: 'lr 12/12/2005 08:38'!
at: aString ifPresent: aBlock
	^ self children at: aString ifPresent: aBlock.! !

!PRChildren methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:57'!
children
	^ children! !

!PRChildren methodsFor: 'configuration' stamp: 'lr 12/12/2005 08:39'!
childrenCollection
	^ Dictionary new.! !

!PRChildren methodsFor: 'enumerating' stamp: 'lr 5/8/2005 10:13'!
do: aBlock
	self children do: aBlock.! !

!PRChildren methodsFor: 'accessing-children' stamp: 'lr 12/12/2005 08:40'!
includes: aString
	^ self children includesKey: aString.! !

!PRChildren methodsFor: 'initialization' stamp: 'lr 12/12/2005 08:39'!
initialize
	super initialize.
	self setChildren: self childrenCollection.! !

!PRChildren methodsFor: 'testing' stamp: 'lr 4/17/2005 11:57'!
isEmpty
	^ children isEmpty.! !

!PRChildren methodsFor: 'testing' stamp: 'lr 2/13/2006 14:50'!
isValidChild: aStructure
	^ aStructure name notNil
		and: [ aStructure name notEmpty
		and: [ aStructure parent isNil
		and: [ (self includes: aStructure name) not
		and: [ (self decorated canBeParentOf: aStructure)
		and: [ (aStructure canBeChildOf: self decorated) ] ] ] ] ].! !

!PRChildren methodsFor: 'copying' stamp: 'lr 12/20/2005 10:02'!
postCopyTo: anObject
	super postCopyTo: anObject.
	self setChildren: self children copy.
	self children keysAndValuesDo: [ :key :value |
		self children at: key put: (value copy 
			postCopyTo: self decorated) ].! !

!PRChildren methodsFor: 'accessing' stamp: 'lr 12/20/2005 18:28'!
priority
	^ 200! !

!PRChildren methodsFor: 'actions' stamp: 'lr 1/5/2006 13:24'!
remove: aStructure
	self children keysAndValuesDo: [ :key :value |
		aStructure = value ifTrue: [ 
			self children removeKey: key.
			self triggerStructureRemoved: value.
			^ value
				parent: nil;
				yourself ] ].
	self error: 'Unable to remove structure from ' , self decorated title , '.'.! !

!PRChildren methodsFor: 'initialization' stamp: 'lr 10/20/2005 17:50'!
setChildren: aCollection
	children := aCollection! !

!PRChildren methodsFor: 'accessing' stamp: 'dc 8/18/2005 16:21'!
size
	^ self children size! !

!PRChildren methodsFor: 'events' stamp: 'lr 2/13/2006 13:44'!
triggerStructureAdded: aStructure
	PRDecoration withAllConcreteClassesDo: [ :each | each onStructureAdded: aStructure ].! !

!PRChildren methodsFor: 'events' stamp: 'lr 2/13/2006 13:44'!
triggerStructureRemoved: aStructure
	PRDecoration withAllConcreteClassesDo: [ :each | each onStructureRemoved: aStructure ].! !

!PRDecoration class methodsFor: 'events' stamp: 'lr 1/5/2006 10:37'!
onStructureAdded: aStructure
	"This event is called whenever a structure is added as a child to another structure."! !

!PRDecoration class methodsFor: 'events' stamp: 'lr 1/5/2006 10:37'!
onStructureRemoved: aStructure
	"This event is called whenever a structure is removed as a child from another structure."! !

!PRDecoration methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitDecoration: self.! !

!PRDecoration methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:54'!
decorated
	^ decorated! !

!PRDecoration methodsFor: 'comparing' stamp: 'lr 1/9/2006 09:16'!
hash
	^ self species hash.! !

!PRDecoration methodsFor: 'testing' stamp: 'lr 2/10/2006 19:18'!
isAllowedCommand: aCommandClass in: aContext
 	"Answer true if the receiver accepts to execute aCommandClass in aContext. The default decoration is fine with all the commands, subclasses might restrict to a selected set of commands within a given context. This method might be overridden by decorations that want to control the security."
	
	^ true! !

!PRDecoration methodsFor: 'copying' stamp: 'lr 12/20/2005 09:54'!
postCopy
	super postCopy.
	self setDecorated: nil.! !

!PRDecoration methodsFor: 'copying' stamp: 'lr 12/20/2005 09:54'!
postCopyTo: anObject
	super postCopyTo: anObject.
	self setDecorated: anObject.! !

!PRDecoration methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
priority
	"The default priority returns a number that defines in witch order the visitors will traverse trough decorated objects. Negative numbers are visited before the decorated obejcts, positive numbers afterwards."
	
	^ self subclassResponsibility.! !

!PRDecoration methodsFor: 'utilities' stamp: 'lr 12/20/2005 18:24'!
remove
	self decorated notNil 
		ifFalse: [ ^ self ].
	self decorated
		removeDecoration: self 
		ifAbsent: [ ].! !

!PRDecoration methodsFor: 'initialization' stamp: 'lr 12/20/2005 09:54'!
setDecorated: aStructure
	decorated := aStructure! !

!PRDecoration methodsFor: 'comparing' stamp: 'lr 10/20/2005 12:18'!
<= aDecoration
	^ self priority <= aDecoration priority.! !

!PRDecoration methodsFor: 'comparing' stamp: 'lr 1/9/2006 09:15'!
= aDecoration
	^ self species = aDecoration species.! !

PRDecoration subclass: #PRHider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRHider class methodsFor: 'testing' stamp: 'lr 12/20/2005 18:46'!
isAbstract
	^ false! !

!PRHider methodsFor: 'visiting' stamp: 'lr 12/20/2005 18:37'!
accept: aVisitor
	aVisitor visitHider: self.! !

!PRHider methodsFor: 'accessing' stamp: 'lr 12/20/2005 18:28'!
priority
	^ -400! !

PRDecoration subclass: #PRMockDecoration
	instanceVariableNames: 'priority'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Utilities'!

!PRMockDecoration class methodsFor: 'testing' stamp: 'lr 12/5/2005 21:32'!
isAbstract
	^ false! !

!PRMockDecoration methodsFor: 'comparing' stamp: 'lr 1/9/2006 09:19'!
hash
	^ super hash bitXor: self priority hash.! !

!PRMockDecoration methodsFor: 'accessing' stamp: 'lr 12/5/2005 21:31'!
priority
	^ priority! !

!PRMockDecoration methodsFor: 'accessing' stamp: 'lr 12/5/2005 21:31'!
priority: anInteger
	priority := anInteger ! !

!PRMockDecoration methodsFor: 'comparing' stamp: 'lr 1/9/2006 09:19'!
= aDecoration
	^ super = aDecoration
		and: [ self priority = aDecoration priority ].! !

PRObject subclass: #PRDocumentItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

PRDocumentItem subclass: #PRAnchor
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRAnchor class methodsFor: 'accessing-description' stamp: 'lr 7/4/2005 08:36'!
descriptionName
	^ MAStringDescription selector: #name label: 'Name'.! !

!PRAnchor class methodsFor: 'testing' stamp: 'lr 7/4/2005 08:35'!
isAbstract
	^ false.! !

!PRAnchor class methodsFor: 'instance creation' stamp: 'lr 7/4/2005 08:39'!
with: aString
	^ self new
		name: aString;
		yourself.! !

!PRAnchor methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitAnchor: self.! !

!PRAnchor methodsFor: 'comparing' stamp: 'lr 7/4/2005 08:37'!
hash
	^ super hash bitXor: self name hash.! !

!PRAnchor methodsFor: 'accessing' stamp: 'lr 10/31/2005 20:34'!
name
	^ name! !

!PRAnchor methodsFor: 'accessing' stamp: 'lr 7/4/2005 08:37'!
name: aString
	name := aString! !

!PRAnchor methodsFor: 'comparing' stamp: 'lr 7/4/2005 08:37'!
= anObject
	^ super = anObject
		and: [ self name = anObject name ].! !

PRDocumentItem subclass: #PRDocumentGroup
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

PRDocumentGroup subclass: #PRDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDocument class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false.! !

!PRDocument methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitDocument: self.! !

!PRDocumentGroup class methodsFor: 'instance creation' stamp: 'lr 4/17/2005 11:59'!
withAll: aCollection 
	^ self new
		addAll: aCollection;
		yourself.! !

!PRDocumentGroup class methodsFor: 'instance creation' stamp: 'lr 10/31/2005 19:32'!
with: aDocumentItem
	^ self new
		add: aDocumentItem;
		yourself.! !

!PRDocumentGroup methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitDocumentGroup: self.! !

!PRDocumentGroup methodsFor: 'adding' stamp: 'lr 10/31/2005 20:30'!
addAll: aCollection
	children := self children copyWithAll: aCollection.! !

!PRDocumentGroup methodsFor: 'adding' stamp: 'lr 10/31/2005 20:32'!
add: aDocumentItem
	children := self children copyWith: aDocumentItem.! !

!PRDocumentGroup methodsFor: 'accessing' stamp: 'lr 10/31/2005 20:28'!
children
	^ children! !

!PRDocumentGroup methodsFor: 'testing' stamp: 'lr 4/17/2005 11:58'!
hasChildren
	^ self children notEmpty.! !

!PRDocumentGroup methodsFor: 'comparing' stamp: 'lr 7/1/2005 15:00'!
hash
	^ super hash bitXor: self children hash.! !

!PRDocumentGroup methodsFor: 'initialization' stamp: 'lr 10/31/2005 20:30'!
initialize
	super initialize.
	children := Array new.! !

!PRDocumentGroup methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
owner: anObject
	super owner: anObject.
	self children do: [ :each | each owner: anObject ].! !

!PRDocumentGroup methodsFor: 'copying' stamp: 'lr 10/31/2005 20:32'!
postCopy
	super postCopy.
	children := self children collect: [ :each | each copy ].! !

!PRDocumentGroup methodsFor: 'accessing-dynamic' stamp: 'lr 11/21/2005 20:28'!
size
	^ self children size.! !

!PRDocumentGroup methodsFor: 'accessing-dynamic' stamp: 'lr 10/21/2005 18:34'!
text
	^ String streamContents: [ :stream |
		self children do: [ :each |
			stream nextPutAll: each text ] ].! !

!PRDocumentGroup methodsFor: 'comparing' stamp: 'lr 7/1/2005 15:00'!
= anObject
	^ super = anObject
		and: [ self children = anObject children ].! !

PRDocumentGroup subclass: #PRHeader
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRHeader class methodsFor: 'accessing-description' stamp: 'lr 4/17/2005 11:59'!
descriptionLevel
	^ MANumberDescription selector: #level label: 'Level'.! !

!PRHeader class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false.! !

!PRHeader class methodsFor: 'instance creation' stamp: 'lr 4/17/2005 11:59'!
withAll: aCollection level: anInteger
	^ (self withAll: aCollection)
		level: anInteger;
		yourself.! !

!PRHeader class methodsFor: 'instance creation' stamp: 'lr 4/17/2005 11:59'!
with: anItem level: anInteger
	^ (self with: anItem)
		level: anInteger;
		yourself.! !

!PRHeader methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitHeader: self.! !

!PRHeader methodsFor: 'comparing' stamp: 'lr 7/1/2005 15:01'!
hash
	^ super hash bitXor: self level hash.! !

!PRHeader methodsFor: 'accessing' stamp: 'lr 10/31/2005 20:36'!
level
	^ level! !

!PRHeader methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
level: anInteger
	level := anInteger! !

!PRHeader methodsFor: 'comparing' stamp: 'lr 7/1/2005 15:01'!
= anObject
	^ super = anObject
		and: [ self level = anObject level ].! !

PRDocumentGroup subclass: #PRLink
	instanceVariableNames: 'reference embedded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRLink commentStamp: '<historical>' prior: 0!
I am an abstract link built from an alias and a reference. The alias is the string representation that will be displayed to the user, whereas the reference is a address-string to the target. If there is no alias, the reference should be displayed.

Examples: 
	*Reference* or *+Reference+*
	*Alias>Reference* or *+Alias>Reference+*!

PRLink subclass: #PRExternalLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRExternalLink class methodsFor: 'accessing-description' stamp: 'lr 10/13/2005 17:54'!
descriptionUrl
	^ (MAStringDescription selector: #url label: 'Url')
		beReadonly.! !

!PRExternalLink class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false! !

!PRExternalLink class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isValidReference: aString
	^ '*://*' match: aString! !

!PRExternalLink class methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
priority
	^ 40! !

!PRExternalLink methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitExternalLink: self.! !

!PRExternalLink methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
url
	^ String streamContents: [ :stream |
		stream 
			nextPutAll: self urlPrefix;
			nextPutAll: self urlEntry;
			nextPutAll: self urlPostfix ].! !

!PRExternalLink methodsFor: 'accessing-dynamic' stamp: 'lr 4/17/2005 11:58'!
urlEntry
	^ self reference.! !

!PRExternalLink methodsFor: 'accessing-dynamic' stamp: 'lr 4/17/2005 11:58'!
urlPostfix
	^ String new.! !

!PRExternalLink methodsFor: 'accessing-dynamic' stamp: 'lr 4/17/2005 11:58'!
urlPrefix
	^ String new.! !

PRExternalLink subclass: #PRIsbnLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRIsbnLink commentStamp: '<historical>' prior: 0!
THIS CLASS HAS NO COMMENT!!

!

!PRIsbnLink class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isValidReference: aString
	^ 'isbn:*' match: aString.! !

!PRIsbnLink class methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
priority
	^ 20! !

!PRIsbnLink methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitIsbnLink: self.! !

!PRIsbnLink methodsFor: 'accessing-dynamic' stamp: 'lr 4/17/2005 11:58'!
urlEntry
	^ super urlEntry copyAfter: $:! !

!PRIsbnLink methodsFor: 'accessing-dynamic' stamp: 'lr 4/17/2005 11:58'!
urlPrefix
	^ 'http://www.amazon.com/exec/obidos/ISBN='! !

PRExternalLink subclass: #PRMailLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRMailLink class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isValidReference: aString
	^ '*@*.*' match: aString.! !

!PRMailLink class methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
priority
	^ 10! !

!PRMailLink methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitMailLink: self.! !

!PRMailLink methodsFor: 'accessing-dynamic' stamp: 'lr 4/17/2005 11:58'!
urlPrefix
	^ 'mailto:'! !

PRExternalLink subclass: #PRRfcLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRRfcLink class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isValidReference: aString
	^ 'rfc:*' match: aString.! !

!PRRfcLink class methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
priority
	^ 30! !

!PRRfcLink methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitRfcLink: self.! !

!PRRfcLink methodsFor: 'accessing-dynamic' stamp: 'lr 4/17/2005 11:58'!
urlEntry
	^ super urlEntry copyAfter: $:! !

!PRRfcLink methodsFor: 'accessing-dynamic' stamp: 'lr 4/17/2005 11:58'!
urlPostfix
	^ '.html'! !

!PRRfcLink methodsFor: 'accessing-dynamic' stamp: 'lr 4/17/2005 11:58'!
urlPrefix
	^ 'http://www.faqs.org/rfcs/rfc'! !

PRLink subclass: #PRInternalLink
	instanceVariableNames: 'owner target anchor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRInternalLink class methodsFor: 'accessing-description' stamp: 'lr 7/5/2005 14:40'!
descriptionAnchor
	^ MAStringDescription selector: #anchor label: 'Anchor'.! !

!PRInternalLink class methodsFor: 'accessing-description' stamp: 'lr 11/17/2005 15:53'!
descriptionTarget
	^ PRStructureDescription selector: #target label: 'Target'.! !

!PRInternalLink class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false! !

!PRInternalLink class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isValidReference: aString
	^ true! !

!PRInternalLink class methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
priority
	^ 50! !

!PRInternalLink class methodsFor: 'instance creation' stamp: 'lr 7/5/2005 14:57'!
reference: aString
	| index |
	^ (index := aString indexOf: $@) isZero
		ifTrue: [ super reference: aString ]
		ifFalse: [
			self new
				reference: (aString copyFrom: 1 to: index - 1);
				anchor: (aString copyFrom: index + 1 to: aString size);
				yourself ].! !

!PRInternalLink methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitInternalLink: self.! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 7/4/2005 21:27'!
anchor
	^ anchor! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 7/4/2005 21:27'!
anchor: aString
	anchor := aString! !

!PRInternalLink methodsFor: 'testing' stamp: 'lr 7/5/2005 07:30'!
hasAnchor
	^ self anchor notNil.! !

!PRInternalLink methodsFor: 'comparing' stamp: 'lr 7/5/2005 07:32'!
hash
	^ super hash bitXor: self anchor hash.! !

!PRInternalLink methodsFor: 'testing' stamp: 'lr 12/22/2005 00:17'!
isBroken
	^ self target isNil.! !

!PRInternalLink methodsFor: 'testing' stamp: 'lr 12/24/2005 16:31'!
isInternal
	^ true! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
owner
	^ owner! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
owner: anObject
	super owner: (owner := anObject).
	self refresh.! !

!PRInternalLink methodsFor: 'actions' stamp: 'lr 1/16/2006 11:20'!
refresh
	"This message will be sent by the structure whenever it is parsed and a reference has to be setup. It simply starts a look-up in the owner using the reference-string. In case the reference is invalid the target will be set to nil and the receiver is in a broken-state."

	self target: (PRPathLookup
		start: self owner
		path: self reference
		onError: [ nil ]).! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 12/22/2005 00:18'!
target
	(target isNil and: [ self hasOwner ])
		ifTrue: [ self refresh ].
	^ target! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
target: aStructure
	target := aStructure! !

!PRInternalLink methodsFor: 'actions' stamp: 'lr 11/17/2005 15:53'!
update
	"This method will be sent to all the internal-links whenever aStructure is renamed or moved to a different location in the wiki. It automatically adjusts the receivers state, so that the reference still points to the right location and don't get broken if the owner page is resaved."

	self reference: (PRPathReference
		from: self owner
		to: self target).! !

!PRInternalLink methodsFor: 'comparing' stamp: 'lr 7/5/2005 07:32'!
= anObject
	^ super = anObject
		and: [ self anchor = anObject anchor ].! !

!PRLink class methodsFor: 'accessing-description' stamp: 'lr 10/13/2005 17:54'!
descriptionAlias
	^ (MAStringDescription selector: #alias label: 'Alias')
		beReadonly;
		yourself.! !

!PRLink class methodsFor: 'accessing-description' stamp: 'lr 10/13/2005 17:54'!
descriptionHasAlias
	^ (MABooleanDescription selector: #hasAlias label: 'Aliased')
		beReadonly;
		yourself.! !

!PRLink class methodsFor: 'accessing-description' stamp: 'lr 10/13/2005 17:54'!
descriptionHasAnchor
	^ (MABooleanDescription selector: #hasAnchor label: 'Anchored')
		beReadonly;
		yourself.! !

!PRLink class methodsFor: 'accessing-description' stamp: 'lr 10/13/2005 17:54'!
descriptionIsBroken
	^ (MABooleanDescription selector: #isBroken label: 'Broken')
		beReadonly;
		yourself.! !

!PRLink class methodsFor: 'accessing-description' stamp: 'lr 7/5/2005 14:40'!
descriptionIsEmbedded
	^ MABooleanDescription selector: #isEmbedded label: 'Embedded'.! !

!PRLink class methodsFor: 'accessing-description' stamp: 'lr 4/17/2005 11:59'!
descriptionReference
	^ MAStringDescription selector: #reference label: 'Reference'.! !

!PRLink class methodsFor: 'instance creation' stamp: 'lr 2/18/2006 14:08'!
fromString: aString
	| classes |
	classes := (self withAllConcreteClasses
		select: [ :each | each isValidReference: aString ])
		asSortedCollection: [ :a :b | a priority < b priority ].
	^ classes first reference: aString.! !

!PRLink class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isValidReference: aString
	self subclassResponsibility.! !

!PRLink class methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
priority
	self subclassResponsibility.! !

!PRLink class methodsFor: 'instance creation' stamp: 'lr 7/5/2005 14:50'!
reference: aString
	^ self new
		reference: aString;
		yourself.! !

!PRLink methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitLink: self.! !

!PRLink methodsFor: 'accessing-dynamic' stamp: 'lr 10/21/2005 18:34'!
alias
	^ self text.! !

!PRLink methodsFor: 'accessing' stamp: 'lr 10/31/2005 20:25'!
embedded
	^ embedded! !

!PRLink methodsFor: 'accessing' stamp: 'lr 7/5/2005 14:30'!
embedded: aBoolean
	embedded := aBoolean! !

!PRLink methodsFor: 'testing' stamp: 'lr 7/1/2005 14:44'!
hasAlias
	^ self hasChildren.! !

!PRLink methodsFor: 'testing' stamp: 'lr 7/5/2005 14:36'!
hasAnchor
	^ false! !

!PRLink methodsFor: 'comparing' stamp: 'lr 7/5/2005 15:03'!
hash
	^ super hash bitXor: (self reference hash bitXor: self embedded hash).! !

!PRLink methodsFor: 'initialization' stamp: 'lr 10/31/2005 20:28'!
initialize
	super initialize.
	self embedded: false.! !

!PRLink methodsFor: 'testing' stamp: 'lr 7/5/2005 07:30'!
isBroken
	^ false! !

!PRLink methodsFor: 'testing' stamp: 'lr 7/8/2005 14:59'!
isEmbedded
	^ self embedded.! !

!PRLink methodsFor: 'testing' stamp: 'lr 12/24/2005 16:30'!
isInternal
	^ false! !

!PRLink methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
reference
	^ reference! !

!PRLink methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
reference: aString
	reference := aString! !

!PRLink methodsFor: 'comparing' stamp: 'lr 7/5/2005 14:32'!
= anObject
	^ super = anObject
		and: [ self reference = anObject reference ]
		and: [ self embedded = anObject embedded ].! !

PRDocumentGroup subclass: #PRList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRList methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitList: self.! !

PRList subclass: #PROrderedList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PROrderedList class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false.! !

!PROrderedList methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitOrderedList: self.! !

PRList subclass: #PRUnorderedList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRUnorderedList class methodsFor: 'testing' stamp: 'lr 4/17/2005 12:00'!
isAbstract
	^ false.! !

!PRUnorderedList methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitUnorderedList: self.! !

PRDocumentGroup subclass: #PRListItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRListItem class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false.! !

!PRListItem methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitListItem: self.! !

PRDocumentGroup subclass: #PRMarkup
	instanceVariableNames: 'tag attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRMarkup class methodsFor: 'testing' stamp: 'lr 2/18/2006 10:38'!
isAbstract
	^ false! !

!PRMarkup methodsFor: 'visiting' stamp: 'lr 2/18/2006 15:51'!
accept: aVisitor
	aVisitor visitMarkup: self.! !

!PRMarkup methodsFor: 'accessing' stamp: 'lr 2/18/2006 15:37'!
attributes
	^ attributes! !

!PRMarkup methodsFor: 'accessing' stamp: 'lr 2/18/2006 15:37'!
attributes: anArray
	attributes := anArray! !

!PRMarkup methodsFor: 'comparing' stamp: 'lr 2/18/2006 15:36'!
hash
	^ super hash bitXor: self tag hash.! !

!PRMarkup methodsFor: 'initialization' stamp: 'lr 2/18/2006 15:38'!
initialize
	super initialize.
	self attributes: #().! !

!PRMarkup methodsFor: 'printing' stamp: 'lr 2/18/2006 15:22'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' tag: '; print: self tag.! !

!PRMarkup methodsFor: 'accessing' stamp: 'lr 2/18/2006 10:25'!
tag
	^ tag! !

!PRMarkup methodsFor: 'accessing' stamp: 'lr 2/18/2006 15:38'!
tag: aString
	tag := aString! !

!PRMarkup methodsFor: 'comparing' stamp: 'lr 2/18/2006 15:36'!
= anObject
	^ super = anObject
		and: [ self tag = anObject tag ]
		and: [ self attributes = anObject attributes ].! !

PRDocumentGroup subclass: #PRParagraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRParagraph class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false.! !

!PRParagraph methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitParagraph: self.! !

PRDocumentGroup subclass: #PRTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRTable class methodsFor: 'accessing-description' stamp: 'lr 11/21/2005 20:24'!
descriptionColumnCount
	^ (MANumberDescription selector: #columnCount label: 'Column Count')
		beReadonly;
		yourself.! !

!PRTable class methodsFor: 'accessing-description' stamp: 'lr 11/21/2005 20:24'!
descriptionRowCount
	^ (MANumberDescription selector: #rowCount label: 'Row Count')
		beReadonly;
		yourself.! !

!PRTable class methodsFor: 'testing' stamp: 'lr 4/17/2005 12:00'!
isAbstract
	^ false.! !

!PRTable methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitTable: self.! !

!PRTable methodsFor: 'accessing' stamp: 'lr 10/20/2005 18:36'!
columnCount
	^ self children inject: 0 into: [ :max :row | max max: row columnCount ].! !

!PRTable methodsFor: 'accessing' stamp: 'lr 10/20/2005 18:35'!
rowCount
	^ self children size.! !

PRDocumentGroup subclass: #PRTableCell
	instanceVariableNames: 'align'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRTableCell class methodsFor: 'accessing-description' stamp: 'lr 11/1/2005 22:31'!
descriptionAlign
	^ (MASingleOptionDescription selector: #align label: 'Align')
		options: #( nil #left #center #right );
		yourself.! !

!PRTableCell class methodsFor: 'testing' stamp: 'lr 4/17/2005 12:00'!
isAbstract
	^ false.! !

!PRTableCell methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitTableCell: self.! !

!PRTableCell methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
align
	^ align! !

!PRTableCell methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
align: aSymbol
	align := aSymbol! !

!PRTableCell methodsFor: 'actions' stamp: 'lr 4/17/2005 11:59'!
beAlignedCenter
	self align: #center.! !

!PRTableCell methodsFor: 'actions' stamp: 'lr 4/17/2005 11:59'!
beAlignedLeft
	self align: #left.! !

!PRTableCell methodsFor: 'actions' stamp: 'lr 4/17/2005 11:59'!
beAlignedRight
	self align: #right.! !

!PRTableCell methodsFor: 'comparing' stamp: 'lr 7/1/2005 15:07'!
hash
	^ super hash bitXor: self align hash.! !

!PRTableCell methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAligned
	^ self align notNil.! !

!PRTableCell methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAlignedCenter
	^ self align = #center.! !

!PRTableCell methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAlignedLeft
	^ self align = #left.! !

!PRTableCell methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAlignedRight
	^ self align = #right.! !

!PRTableCell methodsFor: 'comparing' stamp: 'lr 7/1/2005 15:07'!
= anObject
	^ super = anObject
		and: [ self align = anObject align ].! !

PRDocumentGroup subclass: #PRTableRow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRTableRow class methodsFor: 'accessing-description' stamp: 'lr 10/13/2005 17:55'!
descriptionColumnCount
	^ (MANumberDescription selector: #columnCount label: 'Column Count')
		beReadonly.! !

!PRTableRow class methodsFor: 'testing' stamp: 'lr 4/17/2005 12:00'!
isAbstract
	^ false.! !

!PRTableRow methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitTableRow: self.! !

!PRTableRow methodsFor: 'accessing' stamp: 'lr 10/20/2005 18:36'!
columnCount
	^ self children size.! !

!PRDocumentItem class methodsFor: 'accessing-description' stamp: 'lr 11/21/2005 20:26'!
descriptionHasChildren
	^ (MABooleanDescription selector: #hasChildren label: 'Has Children')
		beReadonly;
		yourself.! !

!PRDocumentItem class methodsFor: 'accessing-description' stamp: 'lr 11/21/2005 20:26'!
descriptionHasOwner
	^ (MABooleanDescription selector: #hasOwner label: 'Has Owner')
		beReadonly;
		yourself.! !

!PRDocumentItem class methodsFor: 'accessing-description' stamp: 'lr 11/21/2005 20:26'!
descriptionOwner
	^ (PRStructureDescription selector: #owner label: 'Owner')
		beReadonly;
		yourself.! !

!PRDocumentItem class methodsFor: 'accessing-description' stamp: 'lr 11/21/2005 20:27'!
descriptionText
	^ (MAStringDescription selector: #text label: 'Text')
		beReadonly;
		yourself.! !

!PRDocumentItem methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitDocumentItem: self.! !

!PRDocumentItem methodsFor: 'testing' stamp: 'lr 4/17/2005 11:58'!
hasChildren
	^ false! !

!PRDocumentItem methodsFor: 'comparing' stamp: 'lr 7/8/2005 13:11'!
hash
	^ self species hash.! !

!PRDocumentItem methodsFor: 'testing' stamp: 'lr 4/17/2005 11:58'!
hasOwner
	^ self owner notNil.! !

!PRDocumentItem methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
owner
	"Return the object owning the receiver. The default implementation doesn't know about its owner and therefor always return nil."
	
	^ nil! !

!PRDocumentItem methodsFor: 'accessing' stamp: 'lr 10/20/2005 17:58'!
owner: anObject
	"Set the owner of the receiver. The default implementation doesn't know about its owner and therefor ignores this message."! !

!PRDocumentItem methodsFor: 'accessing-dynamic' stamp: 'lr 10/21/2005 18:35'!
text
	^ String new.! !

!PRDocumentItem methodsFor: 'comparing' stamp: 'lr 7/8/2005 13:11'!
= anObject
	^ self species = anObject species.! !

PRDocumentItem subclass: #PRHorizontalRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRHorizontalRule class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false.! !

!PRHorizontalRule methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitHorizontalRule: self.! !

PRDocumentItem subclass: #PRPreformatted
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRPreformatted class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false.! !

!PRPreformatted methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitPreformatted: self.! !

PRDocumentItem subclass: #PRText
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRText class methodsFor: 'accessing-configuration' stamp: 'lr 4/17/2005 12:00'!
descriptionText
	^ MAStringDescription selector: #text label: 'Text'.! !

!PRText class methodsFor: 'testing' stamp: 'lr 4/17/2005 12:00'!
isAbstract
	^ false! !

!PRText class methodsFor: 'instance creation' stamp: 'lr 4/17/2005 12:00'!
with: aString
	^ self new
		text: aString;
		yourself.! !

!PRText methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitText: self.! !

!PRText methodsFor: 'comparing' stamp: 'lr 7/1/2005 15:08'!
hash
	^ super hash bitXor: self text hash.! !

!PRText methodsFor: 'printing' stamp: 'lr 4/17/2005 11:59'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' text: '; print: self text.! !

!PRText methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
text
	^ text! !

!PRText methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
text: aString
	text := aString! !

!PRText methodsFor: 'comparing' stamp: 'lr 7/1/2005 15:08'!
= anObject
	^ super = anObject
		and: [ self text = anObject text ].! !

PRObject subclass: #PRKernel
	instanceVariableNames: 'name root persistency mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Kernel'!

PRKernel class
	instanceVariableNames: 'Instances'!

!PRKernel class methodsFor: 'accessing' stamp: 'lr 12/12/2005 08:19'!
instanceNamed: aString
	^ self instances detect: [ :each | each name = aString ].! !

!PRKernel class methodsFor: 'accessing' stamp: 'lr 10/24/2005 08:46'!
instances
	^ Instances ifNil: [ Instances := Set new ].! !

!PRKernel class methodsFor: 'testing' stamp: 'lr 11/1/2005 21:52'!
isAbstract
	^ false! !

!PRKernel class methodsFor: 'instance-creation' stamp: 'lr 10/26/2005 07:20'!
named: aString
	^ self instances add: (self new
		name: aString;
		yourself).! !

!PRKernel class methodsFor: 'private' stamp: 'lr 12/12/2005 08:20'!
reset
	"This method is for development and testing purpose only, you should not call it directly unless you want to loose your wiki-kernels."

	(PRCompatibility confirm: 'Are you sure to drop all kernel instances?')
		ifTrue: [ Instances := nil ].! !

!PRKernel methodsFor: 'conveniance' stamp: 'lr 10/26/2005 07:32'!
critical: aBlock
	^ self mutex critical: aBlock.! !

!PRKernel methodsFor: 'configuration' stamp: 'lr 2/13/2006 17:34'!
defaultInfo
	| structure |
	structure := PRPage named: 'information'.
	structure childrenDecoration 
		add: self defaultInfoIntroduction;
		add: self defaultInfoSyntax;
		add: self defaultInfoLicense.
	structure contents: '-*Introduction>introduction*
-*Syntax>syntax*
-*License>license*'.
	^ structure.! !

!PRKernel methodsFor: 'configuration' stamp: 'lr 2/13/2006 17:34'!
defaultInfoIntroduction
	^ (PRPage named: 'introduction')
		contents: 'The term <i>Wiki</i> usually means the collaborative software used to create, edit and manage hypertext pages on the web. A Wiki enables the users to author their documents using a simple markup language within their preferred web-browser.
Translated from the Hawaiian language <i>Wiki wiki</i> means <i>fast</i> and that is exactly what the collaborative editing process of a WikiWiki Web is all about: Everybody should be able to create and update pages, without the need of user-name and password to login. However there are wiki vandals around that abuse the general public access and make it necessary to protect the content with security mechanism.

!!Problem
There are more than 150 Wiki implementations available and most of them are open source. There are even a few implementations available written in different Smalltalk dialects, so why did we create a new one?
All the implementations we had a look at have major flaws in extensibility: they don''t provide a proper object oriented-design that is covered by unit tests. Moreover they all keep the content of the pages within strings, which makes it painful to render and search the wiki. These wikis haven''t been designed for extensibility!!
The existing Smalltalk wikis are old and it seems that the developers don''t want to touch their running systems. Both, WikiWorks and SqueakWiki, have some of their domain code within external files, what makes the source hard to understand as it is not possible to use the editing and debugging facilities of the Smalltalk environment.

!!Solution
As stated, all the current wiki implementations have problems with extensibility and the design. Redoing the same mistakes is stupid, therefor we put together the following basic requirements and refinded them with the experience we made with the first version:
-<b>Object-Oriented Design:</b> Pier provides a fully object oriented domain model. As an example, the content of the pages is parsed and stored as a tree of different entities representing text, links, tables, lists, etc.
-<b>Extensibility:</b> Everything in Pier can be extended: page types, storage mechanism, actions, security mechanism, web-server, etc. Plug-ins can be shared within the community and loaded independently of each other into the system.
-<b>Open Source:</b> Pier is released under the MIT license which grants unrestricted rights to copy, modify, and redistribute as long as the original copyright and license terms are retained.
-<b>Test Suites:</b> Pier is heavily tested. There are more than 1000 unit tests included with the core of Pier. This makes it easy to change and verify the code and comes in extremely useful when porting Pier to other Smalltalk dialects or when writing extensions.';
		yourself.! !

!PRKernel methodsFor: 'configuration' stamp: 'lr 2/13/2006 14:58'!
defaultInfoLicense
	^ (PRPage named: 'license')
		contents: '!!' , PRDistribution license;
		yourself.! !

!PRKernel methodsFor: 'configuration' stamp: 'lr 2/13/2006 17:41'!
defaultInfoSyntax
	^ (PRPage named: 'syntax')
		contents: '!!Paragraphs
As carriage returns are preserved, simply add a newline to begin a new paragraph.

!!Headers
A line starting with <code>!!</code>s becomes a header line.

!!Horizontal Line
A line starting with <code>_</code> (underline) becomes a horizontal line. This is often used to separate topics.

!!Lists
Using lines starting with <code>#</code>s and <code>-</code>s, creates a list: 
-A block of lines, where each line starts with <code>-</code> is transformed into a bulleted list, where each line is an entry. 
-A block of lines, where each line starts with <code>#</code> is transformed into an ordered list, where each line is an entry.
-Lists can be nested. Thus, a line starting with <code>#-</code> is an element of a bulleted list that is part of an ordered list.

!!Tables
To create a table, start off the lines with <code>|</code> and separate the elements with <code>|</code>s. Each new line represents a new row of the table. The contents of cells can be aligned left, centered or aligned right by using <code>|{</code>, <code>||</code> or <code>|}</code> respectively.

!!Preformatted
To create a preformatted section, begin each line with <code>=</code>. A preformatted section uses equally spaced text so that spacing is preserved. 

!!Links
To create a link, put it between <code>\*</code>s. All links have the following form <code>\*reference\*</code> or <code>\*alias>reference\*</code>, where the reference is depending on the kind of link that is created. The contents of some links, e.g. links pointing to image-files, can be embedded into the current document by using <code>+</code>s: <code>\+reference\+</code>. However not all types of links support embedding and will quietly ignore it.

!!!!Internal Links
If a structure with the given title exists in the wiki (e.g. <code>\*Path\*</code>), a link to that item shows up when the page is saved. In case the path points to an non-existing structure, the user will be offered the possibility to create a new one when clicking on the link. The path can be any absolute or relative  reference within the wiki.

!!!!External Links
-If the link is an URL (e.g. <code>\*http://www.lukas-renggli.ch\*</code>), a link to the external page shows up.
-If the link is an e-mail address (e.g. <code>\*renggli@iam.unibe.ch\*</code>), a link to mail that person shows up.
-If the link is an ISBN number (e.g. <code>\*isbn:3446202102\*</code>), a link to the given book shows up.
-If the link is an RFC number (e.g. <code>\*rfc:2616\*</code>), a link to the given RFC page shows up.

!!HTML
Use any HTML anywhere you want. Some useful HTML tags are:
-To make something <b>bold</b>, surround it by &lt;b&gt; and &lt;/b&gt;.
-To make something <i>italic</i>, surround it by &lt;i&gt; and &lt;/i&gt;.
-To make something <u>underlined</u>, surround it by &lt;u&gt; and &lt;/u&gt;.
-To make text appear in a different color (like <font color="green">green</font>, <font color="red">red</font>, <font color="blue">blue </font>, <font color="grey">grey</font>, <font color="yellow">yellow</font>, or <font color="orange">orange</font>), use &lt;font color="<i>a color</i>"&gt; <i> some text </i> &lt;/font&gt;.';
		yourself.! !

!PRKernel methodsFor: 'configuration' stamp: 'lr 2/13/2006 15:00'!
defaultName
	^ PRDistribution package.! !

!PRKernel methodsFor: 'configuration' stamp: 'lr 2/13/2006 17:34'!
defaultRoot
	| structure |
	structure := PRPage named: 'pier'.
	structure childrenDecoration add: self defaultInfo.
	structure contents: 'Welcome to Pier (formerly called SmallWiki 2), the next generation of a fully extensible content management system implemented in Smalltalk. To read additional information, please consult the *information page>information*.'.
	^ structure.! !

!PRKernel methodsFor: 'accessing-readonly' stamp: 'lr 10/24/2005 17:00'!
mutex
	"Return a mutex (an object that understands #critical:) to be used to make sure that only one process is modifying the model at once. This is needed to ensure that the model remains in a consistent state and all write access must go trough this mutex."

	^ mutex ifNil: [ mutex := Monitor new ].! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 10/24/2005 17:26'!
name
	"Answer the name of the kernel."

	^ name ifNil: [ name := self defaultName ].! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 10/24/2005 17:26'!
name: aString
	"Set the name of the kernel."

	name := aString! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 11/17/2005 15:54'!
persistency
	"Answer the persistency strategy of the receiver."

	^ persistency ifNil: [ persistency := PRNullPersistency new ].! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 10/24/2005 17:26'!
persistency: aPersistency
	"Set the persistency strategy of the receiver."

	persistency := aPersistency
		setKernel: self;
		yourself.! !

!PRKernel methodsFor: 'printing' stamp: 'lr 4/17/2005 11:58'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' name: '; print: self name.! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 10/24/2005 17:26'!
root
	"Answer the root structure of the kernel."

	^ root ifNil: [ root := self defaultRoot ].! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 10/26/2005 07:19'!
root: aStructure
	"Set the root structure of the kernel."

	root := aStructure! !

!PRObject class methodsFor: 'testing' stamp: 'lr 4/17/2005 12:00'!
isAbstract
	^ true! !

!PRObject class methodsFor: 'instance creation' stamp: 'lr 4/17/2005 12:00'!
new
	"Create a new instance of this class and checks if it isn't abstract."

	self isAbstract 
		ifTrue: [ self error: self name , ' is abstract.' ].
	^ super new.! !

!PRObject class methodsFor: 'reflection' stamp: 'lr 4/17/2005 12:00'!
withAllConcreteClasses
	^ Array streamContents: [ :stream |
		self withAllConcreteClassesDo: [ :each |
			stream nextPut: each ] ].! !

!PRObject class methodsFor: 'reflection' stamp: 'lr 4/17/2005 12:00'!
withAllConcreteClassesDo: aBlock
	self withAllSubclassesDo: [ :each |
		each isAbstract ifFalse: [ 
			aBlock value: each ] ].! !

!PRObject methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:40'!
accept: aVisitor
	aVisitor visitObject: self.! !

!PRObject methodsFor: 'private' stamp: 'lr 10/20/2005 12:03'!
errorPropertyNotFound: aSelector
	self error: 'Property ' , aSelector , ' not found.'.! !

!PRObject methodsFor: 'testing' stamp: 'lr 10/20/2005 12:04'!
hasProperty: aKey
	^ self properties includesKey: aKey.! !

!PRObject methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
kind
	"Return the class name of the reciever."

	^ self description label.! !

!PRObject methodsFor: 'copying' stamp: 'lr 10/20/2005 12:04'!
postCopy
	super postCopy.
	properties := properties copy.! !

!PRObject methodsFor: 'copying' stamp: 'lr 10/20/2005 17:19'!
postCopyTo: anObject! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 10/20/2005 12:03'!
properties
	^ properties ifNil: [ properties := Dictionary new ].! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 10/20/2005 12:03'!
propertyAt: aKey
	^ self propertyAt: aKey ifAbsent: [ self errorPropertyNotFound: aKey ].! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 10/20/2005 12:03'!
propertyAt: aKey ifAbsentPut: aBlock
	^ self properties at: aKey ifAbsentPut: aBlock.! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 10/20/2005 12:03'!
propertyAt: aKey ifAbsent: aBlock
	^ self properties at: aKey ifAbsent: aBlock.! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 10/20/2005 12:03'!
propertyAt: aKey put: aValue
	^ self properties at: aKey put: aValue.! !

Object subclass: #PRPersistency
	instanceVariableNames: 'kernel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Persistence'!

PRPersistency subclass: #PRFilePersistency
	instanceVariableNames: 'directory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Persistence'!

!PRFilePersistency class methodsFor: 'instance-creation' stamp: 'lr 1/5/2006 13:03'!
on: aDirectory
	^ self new
		setDirectory: aDirectory;
		yourself.! !

!PRFilePersistency methodsFor: 'accessing' stamp: 'lr 12/9/2005 16:41'!
directory
	^ directory ifNil: [ directory := FileDirectory default ].! !

!PRFilePersistency methodsFor: 'enummerating' stamp: 'lr 1/19/2006 10:27'!
do: aBlock 
	| fileStream |
	fileStream := self directory oldFileNamed: self logFilename.
	[ [ fileStream atEnd ] whileFalse: [
		aBlock value: ((MABinaryReader read: fileStream)
			setKernel: self kernel;
			yourself) ] ]
		ensure: [ fileStream close ].! !

!PRFilePersistency methodsFor: 'accessing' stamp: 'lr 12/9/2005 16:34'!
logFilename
	^ 'logs.obj'! !

!PRFilePersistency methodsFor: 'actions' stamp: 'lr 1/19/2006 09:35'!
log: aContext
	| fileStream referenceStream |
	fileStream := self directory fileNamed: self logFilename.
	[ referenceStream := MACompatibility referenceStream: fileStream setToEnd.
		[ MABinaryWriter write: aContext description: aContext description to: referenceStream ]
			ensure: [ referenceStream close ] ]
		ensure: [ fileStream close ].! !

!PRFilePersistency methodsFor: 'initialization' stamp: 'lr 12/9/2005 16:49'!
setDirectory: aDirectory
	directory := aDirectory! !

!PRFilePersistency methodsFor: 'actions' stamp: 'lr 12/9/2005 20:35'!
snapshot
	| fileStream referenceStream |
	fileStream := self directory fileNamed: self snapshotFilename.
	[ referenceStream := MACompatibility referenceStream: fileStream setToEnd.
		[ referenceStream nextPut: self kernel ]
			ensure: [ referenceStream close ] ]
		ensure: [ fileStream close ].! !

!PRFilePersistency methodsFor: 'accessing' stamp: 'lr 12/9/2005 16:34'!
snapshotFilename
	^ 'snapshots.obj'! !

PRPersistency subclass: #PRImagePersistency
	instanceVariableNames: 'snapshots contexts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Persistence'!

!PRImagePersistency methodsFor: 'enumerating' stamp: 'lr 1/19/2006 10:27'!
do: aBlock
	contexts do: [ :each |
		aBlock value: ((MABinaryReader read: each readStream)
			setKernel: self kernel;
			yourself) ].! !

!PRImagePersistency methodsFor: 'initialization' stamp: 'lr 1/19/2006 09:36'!
initialize
	super initialize.
	snapshots := OrderedCollection new.
	contexts := OrderedCollection new.! !

!PRImagePersistency methodsFor: 'actions' stamp: 'lr 1/19/2006 09:36'!
log: aContext
	contexts add: (MABinaryWriter write: aContext).! !

!PRImagePersistency methodsFor: 'enumerating' stamp: 'lr 1/19/2006 10:27'!
reverseDo: aBlock
	contexts reverseDo: [ :each |
		aBlock value: ((MABinaryReader read: each readStream)
			setKernel: self kernel;
			yourself) ].! !

!PRImagePersistency methodsFor: 'actions' stamp: 'lr 10/14/2005 18:14'!
snapshot
	snapshots add: ((MACompatibility referenceStream: ByteArray new writeStream)
		blockers: (IdentityDictionary new
			at: snapshots put: self;
			yourself);
		nextPut: self kernel;
		contents).! !

PRPersistency subclass: #PRNullPersistency
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Persistence'!

!PRNullPersistency methodsFor: 'enumerating' stamp: 'lr 10/21/2005 15:43'!
do: aBlock! !

!PRNullPersistency methodsFor: 'actions' stamp: 'lr 1/19/2006 09:37'!
log: aContext! !

!PRNullPersistency methodsFor: 'actions' stamp: 'lr 10/21/2005 13:47'!
snapshot! !

!PRPersistency methodsFor: 'enumerating' stamp: 'lr 12/9/2005 11:55'!
do: aBlock
	"Evaluates aBlock in chronological order for every item in the history of the kernel."

	self subclassResponsibility.! !

!PRPersistency methodsFor: 'enumerating' stamp: 'lr 1/19/2006 09:35'!
do: aBlock for: aStructure 
	"Evaluates aBlock in chronological order for every item in the history of aStructure. Subclasses might want to override the default implementation for efficiency."

	self do: [ :each |
		each structure = aStructure
			ifTrue: [ aBlock value: each ] ].! !

!PRPersistency methodsFor: 'conveniance' stamp: 'lr 12/9/2005 12:07'!
history
	^ Array streamContents: [ :stream |
		self do: [ :each | 
			stream nextPut: each ] ].! !

!PRPersistency methodsFor: 'conveniance' stamp: 'lr 12/9/2005 12:06'!
historyFor: aStructure
	^ Array streamContents: [ :stream |
		self 
			do: [ :each | stream nextPut: each ]
			for: aStructure ].! !

!PRPersistency methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
kernel
	^ kernel! !

!PRPersistency methodsFor: 'actions' stamp: 'lr 1/19/2006 09:35'!
log: aContext
	"Log a aContext in the history of the kernel."
	
	self subclassResponsibility.! !

!PRPersistency methodsFor: 'enumerating' stamp: 'lr 12/9/2005 12:07'!
reverseDo: aBlock
	"Evaluates aBlock in inverse chronological order for every item in the history of aStructure. Subclasses might want to override the default implementation for efficiency."

	self history reverseDo: aBlock.! !

!PRPersistency methodsFor: 'enumerating' stamp: 'lr 12/9/2005 12:07'!
reverseDo: aBlock for: aStructure
	"Evaluates aBlock in inverse chronological order for every item in the history of aStructure. Subclasses might want to override the default implementation for efficiency."

	(self historyFor: aStructure)
		reverseDo: aBlock.! !

!PRPersistency methodsFor: 'initialization' stamp: 'lr 10/21/2005 13:45'!
setKernel: aKernel
	kernel := aKernel! !

!PRPersistency methodsFor: 'actions' stamp: 'lr 11/1/2005 22:28'!
snapshot
	"Create a snapshot of the kernel."

	self subclassResponsibility.! !

Object subclass: #PRVisitor
	instanceVariableNames: 'escaper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

PRVisitor subclass: #PRDocumentWriter
	instanceVariableNames: 'stream nesting newline'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDocumentWriter class methodsFor: 'instance-creation' stamp: 'lr 12/22/2005 14:27'!
write: anObject
	^ self new write: anObject.! !

!PRDocumentWriter class methodsFor: 'instance-creation' stamp: 'lr 12/22/2005 14:27'!
write: anObject to: aStream
	^ self new write: anObject to: aStream.! !

!PRDocumentWriter methodsFor: 'streaming' stamp: 'lr 12/22/2005 14:32'!
contents
	^ stream contents.! !

!PRDocumentWriter methodsFor: 'private' stamp: 'lr 12/22/2005 14:34'!
defaultStream
	^ String new writeStream.! !

!PRDocumentWriter methodsFor: 'private' stamp: 'lr 12/22/2005 14:49'!
nest: aCharacter do: aBlock
	nesting := nesting copyWith: aCharacter.
	aBlock ensure: [ nesting := nesting allButLast ].! !

!PRDocumentWriter methodsFor: 'private' stamp: 'lr 11/2/2005 21:38'!
newLine
	stream isEmpty 
		ifFalse: [ stream nextPut: Character cr ].
	newline := true.! !

!PRDocumentWriter methodsFor: 'streaming' stamp: 'lr 12/22/2005 14:48'!
nextPutAll: aString
	stream nextPutAll: aString.
	newline := false.! !

!PRDocumentWriter methodsFor: 'streaming' stamp: 'lr 12/22/2005 14:48'!
nextPut: aCharacter
	stream nextPut: aCharacter.
	newline := false.! !

!PRDocumentWriter methodsFor: 'visiting' stamp: 'lr 12/22/2005 14:50'!
start: anObject
	newline := true.
	nesting := String new.
	super start: anObject.! !

!PRDocumentWriter methodsFor: 'accessing' stamp: 'lr 12/22/2005 14:31'!
stream
	^ stream! !

!PRDocumentWriter methodsFor: 'accessing' stamp: 'lr 12/22/2005 14:32'!
stream: aStream
	stream := aStream! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 7/4/2005 08:39'!
visitAnchor: anObject
	self newLine; nextPut: $@; nextPutAll: anObject name.! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 4/17/2005 11:58'!
visitHeader: anObject
	self newLine; nextPutAll: (String new: anObject level withAll: $!!).
	super visitHeader: anObject.! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 4/17/2005 11:58'!
visitHorizontalRule: anObject
	self newLine; nextPut: $_.! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 7/4/2005 19:30'!
visitLink: anObject
	anObject isEmbedded
		ifTrue: [ self nextPut: $+ ]
		ifFalse: [ self nextPut: $* ].
	anObject hasAlias ifTrue: [ 
		super visitLink: anObject.
		self nextPut: $> ].
	self nextPutAll: anObject reference.
	anObject hasAnchor ifTrue: [
		self nextPut: $@.
		self nextPutAll: anObject anchor ].
	anObject isEmbedded 
		ifTrue: [ self nextPut: $+ ]
		ifFalse: [ self nextPut: $* ].
	! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 4/17/2005 11:58'!
visitListItem: anObject
	newline ifFalse: [ self newLine ].
	self nextPutAll: nesting.
	super visitListItem: anObject.! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 4/17/2005 11:58'!
visitOrderedList: anObject
	self newLine.
	self nest: $# do: [ super visitOrderedList: anObject ].! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 4/17/2005 11:58'!
visitParagraph: anObject
	self newLine.
	super visitParagraph: anObject.! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 4/17/2005 11:58'!
visitPreformatted: anObject
	anObject children 
		do: [ :each | self newLine; nextPut: $=; nextPutAll: each text ].! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 4/17/2005 11:58'!
visitTableCell: anObject
	self nextPut: $|.
	anObject isAligned ifTrue: [
		anObject isAlignedLeft ifTrue: [ self nextPut: ${ ].
		anObject isAlignedCenter ifTrue: [ self nextPut: $| ].
		anObject isAlignedRight ifTrue: [ self nextPut: $} ] ].
	super visitTableCell: anObject.! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 4/17/2005 11:58'!
visitTableRow: anObject
	self newLine.
	super visitTableRow: anObject.! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 2/18/2006 17:58'!
visitText: anObject
	"Write out aText to the receivers output-stream and escape $* everywhere withing. Also take care of the character escaping with $=, $|, $!!, $# and $- at the beginning of a line."

	anObject text do: [ :each |
		(('*+<\' includes: each) or: [ newline and: [ '=@|!!#-' includes: each ] ]) 
			ifTrue: [ self nextPut: $\ ].
		self nextPut: each ].! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 4/17/2005 11:58'!
visitUnorderedList: anObject
	self newLine.
	self nest: $- do: [ super visitUnorderedList: anObject ].! !

!PRDocumentWriter methodsFor: 'visiting' stamp: 'lr 12/22/2005 14:29'!
write: anObject
	^ self write: anObject to: self defaultStream.! !

!PRDocumentWriter methodsFor: 'visiting' stamp: 'lr 12/22/2005 14:33'!
write: anObject to: aStream
	^ self stream: aStream; start: anObject; contents.! !

PRVisitor subclass: #PRGraphChecker
	instanceVariableNames: 'fix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRGraphChecker methodsFor: 'private' stamp: 'lr 1/9/2006 09:47'!
assert: aBoolean description: aString fix: aBlock
	aBoolean ifTrue: [ ^ self ].
	Transcript show: aString; show: '... '.
	self isReadonly ifFalse: [
		aBlock
			on: Error
			do: [ :err | Transcript show: err ].
		Transcript show: 'done' ].
	Transcript cr.! !

!PRGraphChecker methodsFor: 'testing' stamp: 'lr 1/9/2006 09:41'!
isReadonly
	^ false! !

!PRGraphChecker methodsFor: 'visiting-structure' stamp: 'lr 2/13/2006 18:04'!
visitChildren: anObject
	super visitChildren: anObject.
	anObject children keysAndValuesDo: [ :key :value |
		self
			assert: key = value name
			description: value printString , ' has invalid name'
			fix: [ value name: key ].
		self
			assert: value parent == anObject decorated
			description: value printString , ' has invalid parent-pointer in ' , anObject printString
			fix: [ value parent: anObject decorated ] ].
	self visitAll: anObject children.! !

!PRGraphChecker methodsFor: 'visiting-structure' stamp: 'lr 1/9/2006 09:52'!
visitDecorated: anObject
	super visitDecorated: anObject.
	self
		assert: anObject decorations size = anObject decorations asSet size
		description: anObject printString , ' has duplicated decorations'
		fix: [ anObject explore ].
	self 
		assert: anObject decorations = anObject decorations copy sort
		description: anObject printString , ' has unsorted decorations'
		fix: [ anObject decorations sort ].
	anObject decorations do: [ :each |
		self
			assert: each decorated == anObject
			description: each printString , ' has invalid parent-pointer in ' , anObject printString
			fix: [ each setDecorated: anObject ] ].! !

PRVisitor subclass: #PRPath
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

PRPath subclass: #PRPathLookup
	instanceVariableNames: 'pathElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

PRPathLookup subclass: #PRIncompletePathLookup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRIncompletePathLookup class methodsFor: 'instance creation' stamp: 'lr 4/17/2005 11:59'!
start: aStructure path: aString
	| visitor |
	visitor := self new
		stream: aString readStream;
		yourself.
	^ Association
		key: (visitor lookup: aStructure)
		value: visitor pathElement.! !

!PRIncompletePathLookup methodsFor: 'private' stamp: 'lr 4/17/2005 11:58'!
childNotFound: aStructure
	self readNext; escape: aStructure.! !

!PRPathLookup class methodsFor: 'instance creation' stamp: 'lr 4/17/2005 11:59'!
start: aStructure path: aString
	^ self new
		stream: aString readStream;
		lookup: aStructure.! !

!PRPathLookup class methodsFor: 'instance creation' stamp: 'lr 4/17/2005 11:59'!
start: aStructure path: aString onError: aBlock
	^ [ self start: aStructure path: aString ]
		on: Error
		do: [ :error | aBlock value ].! !

!PRPathLookup methodsFor: 'private' stamp: 'lr 4/17/2005 11:58'!
childNotFound: aStructure
	self error: 'Invalid path ' , self stream contents.! !

!PRPathLookup methodsFor: 'actions' stamp: 'lr 4/17/2005 11:58'!
lookupRoot: aStructure
	self stream next.
	self visit: aStructure root.! !

!PRPathLookup methodsFor: 'actions' stamp: 'lr 4/17/2005 11:58'!
lookupStart: aStructure
	self visit: aStructure.! !

!PRPathLookup methodsFor: 'actions' stamp: 'lr 4/17/2005 11:58'!
lookup: aStructure
	^ self withEscaper: [
		self stream peek = self separator
			ifTrue: [ self lookupRoot: aStructure ]
			ifFalse: [ self lookupStart: aStructure ].
		self childNotFound: aStructure ].! !

!PRPathLookup methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
pathElement
	^ pathElement! !

!PRPathLookup methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
pathElement: aString 
	pathElement := aString! !

!PRPathLookup methodsFor: 'private' stamp: 'lr 2/13/2006 14:43'!
readNext
	^ self stream upTo: self separator.! !

!PRPathLookup methodsFor: 'visiting-decorations' stamp: 'lr 12/20/2005 10:03'!
visitChildren: anObject
	self visit: (anObject
		at: self pathElement
		ifAbsent: [ self childNotFound: anObject decorated ]).! !

!PRPathLookup methodsFor: 'visiting-structure' stamp: 'lr 4/17/2005 11:58'!
visitStructure: aStructure
	self stream atEnd
		ifTrue: [ self escape: aStructure ].
	self pathElement: self readNext.
	self pathElement = self parent ifTrue: [
		self visit: (aStructure isRoot
			ifTrue: [ aStructure ]
			ifFalse: [ aStructure parent ]) ].
	aStructure hasChildren
		ifFalse: [ self childNotFound: aStructure ].! !

PRPath subclass: #PRPathReference
	instanceVariableNames: 'source sourceParents target targetParents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRPathReference class methodsFor: 'instance creation' stamp: 'lr 2/13/2006 13:58'!
from: aFirstStructure to: aSecondStructure
	^ self new
		setSource: aFirstStructure;
		setTarget: aSecondStructure;
		reference.! !

!PRPathReference class methodsFor: 'instance creation' stamp: 'lr 4/17/2005 11:59'!
to: aStructure
	^ self from: aStructure root to: aStructure.! !

!PRPathReference methodsFor: 'initialization' stamp: 'lr 4/17/2005 11:58'!
initialize
	super initialize.
	stream := WriteStream on: String new.! !

!PRPathReference methodsFor: 'actions' stamp: 'lr 2/13/2006 14:41'!
reference
	self source isRoot ifTrue: [ self writeSeparator ].
	self source = self target ifTrue: [ ^ self stream contents ].
	self sourceParents removeFirst = self targetParents removeFirst
		ifFalse: [ self error: 'Unable to reference external wiki.' ].
	[ self sourceParents notEmpty 
		and: [ self targetParents notEmpty
		and: [ self sourceParents first = self targetParents first ] ] ] whileTrue: [ 
			self sourceParents removeFirst. 
			self targetParents removeFirst ].
	self sourceParents reverseDo: [ :each |
		self writeParent; writeSeparator ].
	self targetParents do: [ :each |
		self visit: each; writeSeparator ].
	^ self stream skip: -1; contents.! !

!PRPathReference methodsFor: 'initialization' stamp: 'lr 2/13/2006 13:59'!
setSource: aStructure
	source := aStructure! !

!PRPathReference methodsFor: 'initialization' stamp: 'lr 2/13/2006 13:59'!
setTarget: aStructure
	target := aStructure! !

!PRPathReference methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
source
	^ source! !

!PRPathReference methodsFor: 'accessing-dynamic' stamp: 'lr 2/13/2006 13:58'!
sourceParents
	^ sourceParents ifNil: [ sourceParents := self source parents ].! !

!PRPathReference methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
target
	^ target! !

!PRPathReference methodsFor: 'accessing-dynamic' stamp: 'lr 2/13/2006 13:58'!
targetParents
	^ targetParents ifNil: [ targetParents := self target parents ].! !

!PRPathReference methodsFor: 'visiting-structure' stamp: 'lr 2/13/2006 14:00'!
visitStructure: aStructure
	stream nextPutAll: aStructure name.! !

!PRPathReference methodsFor: 'private' stamp: 'lr 4/17/2005 11:58'!
writeParent
	stream nextPutAll: self parent.! !

!PRPathReference methodsFor: 'private' stamp: 'lr 4/17/2005 11:58'!
writeSeparator
	stream nextPut: self separator.! !

!PRPath methodsFor: 'accessing-configuration' stamp: 'lr 4/17/2005 11:58'!
parent
	^ '..'! !

!PRPath methodsFor: 'accessing-configuration' stamp: 'lr 2/13/2006 13:57'!
separator
	^ $/! !

!PRPath methodsFor: 'accessing' stamp: 'lr 7/8/2005 10:48'!
stream
	^ stream! !

!PRPath methodsFor: 'accessing' stamp: 'lr 7/8/2005 10:48'!
stream: aStream
	stream := aStream! !

PRVisitor subclass: #PRPluggableVisitor
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

PRPluggableVisitor subclass: #PRChildrenVisitor
	instanceVariableNames: 'structure with all hidden'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRChildrenVisitor class methodsFor: 'instance creation' stamp: 'lr 1/14/2006 16:07'!
on: aStructure
	^ self new
		setStructure: aStructure;
		yourself.! !

!PRChildrenVisitor methodsFor: 'setting' stamp: 'lr 1/14/2006 16:27'!
all
	"Tell the receiver to visit structures recursively."

	all := true! !

!PRChildrenVisitor methodsFor: 'setting' stamp: 'lr 1/14/2006 17:16'!
all: aBoolean
	all := aBoolean! !

!PRChildrenVisitor methodsFor: 'visiting' stamp: 'lr 1/14/2006 16:25'!
contents
	"Answer a collection of all visitors that have been visited."

	^ Array streamContents: [ :stream | 
		self do: [ :each | stream nextPut: each ] ].! !

!PRChildrenVisitor methodsFor: 'visiting' stamp: 'lr 1/14/2006 16:25'!
do: aBlock
	"Evaluate aBlock for every structure visited by the receiver."

	self block: aBlock; start: structure.! !

!PRChildrenVisitor methodsFor: 'setting' stamp: 'lr 1/14/2006 15:57'!
hidden
	"Tell the receiver to visit hidden structures."

	hidden := true! !

!PRChildrenVisitor methodsFor: 'setting' stamp: 'lr 1/14/2006 17:16'!
hidden: aBoolean
	hidden := aBoolean! !

!PRChildrenVisitor methodsFor: 'initialization' stamp: 'lr 1/14/2006 15:53'!
initialize
	super initialize.
	with := all := hidden := false.! !

!PRChildrenVisitor methodsFor: 'initialization' stamp: 'lr 1/14/2006 16:07'!
setStructure: aStructure
	structure := aStructure! !

!PRChildrenVisitor methodsFor: 'visiting' stamp: 'lr 1/14/2006 16:24'!
start: anObject
	self withEscaper: [ super start: anObject ].! !

!PRChildrenVisitor methodsFor: 'visiting-decoration' stamp: 'lr 2/13/2006 15:48'!
visitChildren: anObject
	(all or: [ structure == anObject decorated ]) 
		ifFalse: [ ^ self ].
	anObject do: [ :each |
		self withEscaper: [
			self visit: each ] ].! !

!PRChildrenVisitor methodsFor: 'visiting-decoration' stamp: 'lr 1/14/2006 16:02'!
visitHider: anObject
	hidden ifFalse: [ self escape: anObject ].! !

!PRChildrenVisitor methodsFor: 'visiting-structure' stamp: 'lr 1/14/2006 16:03'!
visitStructure: aStructure
	(with or: [ structure ~~ aStructure ])
		ifTrue: [ block value: aStructure ].! !

!PRChildrenVisitor methodsFor: 'setting' stamp: 'lr 1/14/2006 15:58'!
with
	"Tell the receiver to visit the start structure as well."

	with := true! !

!PRChildrenVisitor methodsFor: 'setting' stamp: 'lr 1/14/2006 17:16'!
with: aBoolean
	with := aBoolean! !

PRPluggableVisitor subclass: #PRFullTextSearch
	instanceVariableNames: 'searchText caseSensitive lastMatch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRFullTextSearch class methodsFor: 'instance creation' stamp: 'lr 2/10/2006 18:57'!
from: aStructure find: aString caseSensitive: aBoolean
	^ Array streamContents: [ :stream |
		self 
			from: aStructure
			find: aString caseSensitive: aBoolean
			do: [ :each | stream nextPut: each ] ].! !

!PRFullTextSearch class methodsFor: 'instance creation' stamp: 'lr 2/10/2006 18:57'!
from: aStructure find: aString caseSensitive: aBoolean do: aBlock
	^ self new
		block: aBlock;
		searchText: aString;
		caseSensitive: aBoolean;
		start: aStructure;
		yourself.! !

!PRFullTextSearch methodsFor: 'accessing' stamp: 'lr 2/10/2006 18:52'!
caseSensitive
	^ caseSensitive! !

!PRFullTextSearch methodsFor: 'accessing' stamp: 'lr 2/10/2006 18:52'!
caseSensitive: aBoolean
	caseSensitive := aBoolean! !

!PRFullTextSearch methodsFor: 'private' stamp: 'lr 2/10/2006 20:10'!
check: aString in: aStructure
	(lastMatch ~= aStructure and: [ aString includesSubstring: self searchText caseSensitive: self caseSensitive ])
		ifTrue: [ self block value: (lastMatch := aStructure) ].! !

!PRFullTextSearch methodsFor: 'accessing' stamp: 'lr 2/10/2006 18:24'!
searchText
	^ searchText! !

!PRFullTextSearch methodsFor: 'accessing' stamp: 'lr 2/10/2006 18:24'!
searchText: aString
	searchText := aString! !

!PRFullTextSearch methodsFor: 'visiting-decoration' stamp: 'lr 2/10/2006 18:25'!
visitChildren: anObject
	self visitAll: anObject children.! !

!PRFullTextSearch methodsFor: 'visiting-structure' stamp: 'lr 2/10/2006 18:55'!
visitPage: aStructure
	super visitPage: aStructure.
	self check: aStructure document text in: aStructure.! !

!PRFullTextSearch methodsFor: 'visiting-structure' stamp: 'lr 2/13/2006 15:21'!
visitStructure: aStructure! !

!PRPluggableVisitor methodsFor: 'accessing' stamp: 'lr 11/1/2005 06:49'!
block
	^ block! !

!PRPluggableVisitor methodsFor: 'accessing' stamp: 'lr 1/14/2006 15:56'!
block: aBlock
	block := aBlock! !

PRPluggableVisitor subclass: #PRReferences
	instanceVariableNames: 'structures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRReferences class methodsFor: 'instance creation' stamp: 'lr 11/1/2005 06:57'!
from: aStructure to: aCollection
	^ Array streamContents: [ :stream |
		self 
			from: aStructure to: aCollection
			do: [ :each | stream nextPut: each ] ].! !

!PRReferences class methodsFor: 'instance creation' stamp: 'lr 1/14/2006 15:57'!
from: aStructure to: aCollectionOrStructure do: aBlock
	"Evaluates aBlock for every internal-link referencing on of the structures in aCollection starting at aStructure."
		
	^ self new
		block: aBlock;
		structures: (aCollectionOrStructure isCollection
			ifTrue: [ aCollectionOrStructure asSet ]
			ifFalse: [ Set with: aCollectionOrStructure ]);
		start: aStructure;
		yourself.! !

!PRReferences methodsFor: 'accessing' stamp: 'lr 11/1/2005 06:53'!
structures
	^ structures! !

!PRReferences methodsFor: 'accessing' stamp: 'lr 11/1/2005 06:53'!
structures: aCollection
	structures := aCollection! !

!PRReferences methodsFor: 'visiting-decoration' stamp: 'lr 10/20/2005 17:04'!
visitChildren: anObject
	self visitAll: anObject children.! !

!PRReferences methodsFor: 'visiting-document' stamp: 'lr 11/1/2005 07:09'!
visitInternalLink: anObject
	(self structures includes: anObject target)
		ifTrue: [ self block value: anObject ].! !

!PRReferences methodsFor: 'visiting-structure' stamp: 'lr 11/1/2005 06:52'!
visitPage: anObject
	self visit: anObject document.! !

!PRVisitor class methodsFor: 'instance creation' stamp: 'lr 4/17/2005 12:00'!
visit: anObject
	^ self new
		start: anObject;
		yourself.! !

!PRVisitor methodsFor: 'escaping' stamp: 'lr 4/17/2005 11:59'!
escape: anObject
	escaper value: anObject.! !

!PRVisitor methodsFor: 'escaping' stamp: 'lr 4/17/2005 11:59'!
hasEscaper
	^ escaper notNil.! !

!PRVisitor methodsFor: 'visiting' stamp: 'lr 4/17/2005 11:59'!
start: anObject
	self visit: anObject.! !

!PRVisitor methodsFor: 'visiting' stamp: 'lr 4/17/2005 11:59'!
visitAll: aCollection
	aCollection do: [ :each | self visit: each ].! !

!PRVisitor methodsFor: 'visiting' stamp: 'lr 4/17/2005 11:59'!
visitAll: aCollection separatedBy: aBlock
	aCollection do: [ :each | self visit: each ] separatedBy: aBlock.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:32'!
visitAnchor: anObject
	self visitDocumentItem: anObject.! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 10/20/2005 13:32'!
visitChildren: anObject
	self visitDecoration: anObject.! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 10/20/2005 15:54'!
visitDecorated: anObject
	self visitObject: anObject.! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 10/20/2005 13:32'!
visitDecoration: anObject
	self visitObject: anObject.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:38'!
visitDocumentGroup: anObject
	self visitDocumentItem: anObject.
	self visitAll: anObject children.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:40'!
visitDocumentItem: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:32'!
visitDocument: anObject
	self visitDocumentGroup: anObject.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:32'!
visitExternalLink: anObject
	self visitLink: anObject.! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 10/20/2005 13:32'!
visitFile: anObject
	self visitStructure: anObject.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:32'!
visitHeader: anObject
	self visitDocumentGroup: anObject.! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 12/20/2005 18:38'!
visitHider: anObject
	self visitDecoration: anObject.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:32'!
visitHorizontalRule: anObject
	self visitDocumentItem: anObject.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:32'!
visitInternalLink: anObject
	self visitLink: anObject.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:32'!
visitIsbnLink: anObject
	self visitExternalLink: anObject.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:32'!
visitLink: anObject
	self visitDocumentGroup: anObject.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:32'!
visitListItem: anObject
	self visitDocumentGroup: anObject.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:32'!
visitList: anObject
	self visitDocumentGroup: anObject.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:32'!
visitMailLink: anObject
	self visitExternalLink: anObject.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 2/18/2006 17:42'!
visitMarkup: anObject
	self visitDocumentGroup: anObject.! !

!PRVisitor methodsFor: 'visiting-core' stamp: 'lr 10/20/2005 13:32'!
visitObject: anObject
! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:32'!
visitOrderedList: anObject
	self visitList: anObject.! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 10/20/2005 13:32'!
visitPage: anObject
	self visitStructure: anObject.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:32'!
visitParagraph: anObject
	self visitDocumentGroup: anObject.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 2/18/2006 19:07'!
visitPreformatted: anObject
	self visitDocumentItem: anObject.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:32'!
visitRfcLink: anObject
	self visitExternalLink: anObject.! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 10/20/2005 15:54'!
visitStructure: anObject
	self visitDecorated: anObject.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:32'!
visitTableCell: anObject
	self visitDocumentGroup: anObject.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:32'!
visitTableRow: anObject
	self visitDocumentGroup: anObject.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:32'!
visitTable: anObject
	self visitDocumentGroup: anObject.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:32'!
visitText: anObject
	self visitDocumentItem: anObject.! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 10/20/2005 13:32'!
visitUnorderedList: anObject
	self visitList: anObject.! !

!PRVisitor methodsFor: 'visiting' stamp: 'lr 4/17/2005 11:59'!
visit: anObject
	anObject acceptDecorated: self.! !

!PRVisitor methodsFor: 'escaping' stamp: 'lr 4/17/2005 11:59'!
withEscaper: aBlock
	| old |
	old := escaper. 
	escaper := [ :value | ^ value ].
	^ aBlock ensure: [ escaper := old ].! !

MADistribution subclass: #PRDistribution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Core'!

!PRDistribution class methodsFor: 'accessing' stamp: 'lr 11/17/2005 19:21'!
package
	"The SqueakMap package name."

	^ 'Pier'! !

!PRDistribution class methodsFor: 'accessing' stamp: 'lr 1/7/2006 14:35'!
packages
	^ #( ( 'Pier-Model' )
		 ( 'Pier-Tests' 'Smalltalk includesKey: #TestCase' )
		 ( 'Pier-Seaside' 'Smalltalk includesKey: #WAComponent' ) 
		 ( 'Pier-OmniBrowser' 'Smalltalk includesKey: #OBBrowser' ) ).! !

!PRDistribution class methodsFor: 'execution' stamp: 'lr 11/17/2005 20:01'!
postload
	self registerRepository: 'http://mc.lukas-renggli.ch/pier'.! !

!PRDistribution class methodsFor: 'accessing' stamp: 'lr 1/7/2006 15:00'!
preamble
	^ '(SMSqueakMap default packageWithName: ''Magritte'')
	lastRelease install.' , String cr.! !

!PRDistribution class methodsFor: 'accessing' stamp: 'lr 1/7/2006 14:11'!
version
	"The first item is the product name, which should only contain lowercase letters. Then the version numbers are following, that are made up of three numbers. An optimal suffix alpha, beta, pre or rc follows. External packages or extensions might want to call this method to check the version required to run."

	^ #( pier 1 0 2 alpha ).! !

!MABinaryReader methodsFor: '*pier-model-visiting-description' stamp: 'lr 11/17/2005 15:25'!
visitStructureDescription: aDescription
	self object
		write: (PRPathLookup
			start: self context root
			path: self stream next
			onError: [ nil ])
		using: aDescription.! !

MACompatibility subclass: #PRCompatibility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Core'!

!PRCompatibility class methodsFor: 'development-tools' stamp: 'lr 11/20/2005 20:08'!
compileFileNamed: aString into: aClass selector: aSelector
	"Reads the file with the name aString and compile it into aClass>>aSelector returning the the contents as byte-array."

	| input contents source |
	input := FileDirectory default oldFileNamed: aString.
	contents := [ input binary; contents ] ensure: [ input close ].
	source := String streamContents: [ :stream |
		stream nextPutAll: aSelector; cr.
		stream tab; nextPut: $"; nextPutAll: self name; nextPutAll: ' compileFileNamed: '; print: aString; nextPutAll: ' into: '; print: aClass; nextPutAll: ' selector: '; print: aSelector; nextPut: $"; cr; cr.
		stream tab; nextPutAll: '^ #('.
		contents asByteArray
			do: [ :element | element printOn: stream ]
			separatedBy: [ stream space ].
		stream nextPutAll: ') asByteArray.' ].
	aClass compile: source classified: #'accessing-resources'.! !

!PRCompatibility class methodsFor: 'environment' stamp: 'lr 12/20/2005 11:39'!
hashPassword: aString
	"Answer a secure-hash value to be used to store and compare passwords in a save way."

	^ SecureHashAlgorithm new hashMessage: aString.! !

SmaCCParser subclass: #PRTextParser
	instanceVariableNames: 'document items stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRTextParser class methodsFor: 'generated-comments' stamp: 'lr 2/18/2006 15:55'!
parserDefinitionComment

	"# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

Line		: LineItem* { items } ;

LineItem	: Text 'text' { self addText: text }
			| Link 'link' { self addLink: link }
			| Xml 'xml'
			| Any 'text' { self addText: text } ;

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

Text			: <string> 'string' { self parseText: string value }
			| <escaped> 'string' { self parseText: string value allButFirst } ;

Link		: <link> 'link' { self parseLink: link value } ;

Xml			: <xmlclose> 'xml' { self closeTag: (self parseXml: xml value start: 3 end: 1) }
			| <xmlshort> 'xml' { self shortTag: (self parseXml: xml value start: 2 end: 2) } 
			| <xmlopen> 'xml' { self openTag: (self parseXml: xml value start: 2 end: 1) } ;

Any		: <any> 'string' { self parseText: string value } ;

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #"! !

!PRTextParser class methodsFor: 'generated-accessing' stamp: 'lr 2/19/2006 09:46'!
scannerClass
	^PRDocumentScanner! !

!PRTextParser class methodsFor: 'generated-starting states' stamp: 'lr 2/18/2006 15:55'!
startingStateForLine
	^1! !

!PRTextParser methodsFor: 'adding' stamp: 'lr 2/18/2006 15:45'!
addLink: anObject
	items addLast: anObject.! !

!PRTextParser methodsFor: 'adding' stamp: 'lr 2/18/2006 15:45'!
addText: aText
	(items notEmpty and: [ items last class = aText class ])
		ifTrue: [ items last text: items last text , aText text ]
		ifFalse: [ items addLast: aText ].! !

!PRTextParser methodsFor: 'adding-xml' stamp: 'lr 2/18/2006 15:40'!
closeTag: aXmlTag
	| index |
	index := items findLast: [ :each | 
		each class = aXmlTag class 
			and: [ each tag = aXmlTag tag ] ].
	index isZero
		ifTrue: [ ^ self ].
	(items at: index)
		addAll: (items 
			copyFrom: index + 1 
			to: items size).
	items removeLast: items size - index.! !

!PRTextParser methodsFor: 'initialization' stamp: 'lr 2/19/2006 09:50'!
initialize
	super initialize.
	document := OrderedCollection new.
	items := OrderedCollection new.! !

!PRTextParser methodsFor: 'adding-xml' stamp: 'lr 2/18/2006 15:45'!
openTag: aXmlTag
	items addLast: aXmlTag.! !

!PRTextParser methodsFor: 'parsing' stamp: 'lr 2/19/2006 09:50'!
parse
	! !

!PRTextParser methodsFor: 'parsing' stamp: 'lr 2/19/2006 09:57'!
parseLine
	(self stream peek = $@)
		ifTrue: [ ^ self parseAnchor ].
	(self stream peek = $!!)
		ifTrue: [ ^ self parseHeader ].
	(self stream peek = $- or: [ self stream peek = $# ])
		ifTrue: [ ^ self parseList ].
	(self stream peek = $|)
		ifTrue: [ ^ self parseTable ].
	(self stream peek = Character cr or: [ self stream peek = Character lf ])
		ifTrue: [ ^ self parseBlank ].
	^ self parseParagraph.
	! !

!PRTextParser methodsFor: 'parsing-text' stamp: 'lr 2/18/2006 17:48'!
parseLink: aString
	| string index alias link |
	string := aString copyFrom: 2 to: aString size - 1.
	index := string indexOf: $> ifAbsent: [ 0 ].
	alias := nil.
	index isZero ifFalse: [
		alias := string copyFrom: 1 to: index - 1. 
		string := string copyFrom: index + 1 to: string size ].
	link := PRLink fromString: string.
	alias isNil
		ifFalse: [ link add: (PRText with: alias) ].
	^ link
		embedded: aString first = $+;
		yourself.! !

!PRTextParser methodsFor: 'parsing-text' stamp: 'lr 2/18/2006 15:47'!
parseText: aString
	^ PRText with: aString.! !

!PRTextParser methodsFor: 'parsing-text' stamp: 'lr 2/18/2006 17:14'!
parseXml: aString start: aStartInteger end: anEndInteger
	| stream element |
	stream := (aString copyFrom: aStartInteger to: aString size - anEndInteger)
		readStream.
	[ stream atEnd or: [ stream peek = $/ or: [ stream peek isSeparator not ] ] ]
		whileFalse: [ stream next ].
	element := PRMarkup new
		tag: (String streamContents: [ :output |
			[ stream atEnd or: [ stream peek = $/ or: [ stream peek isSeparator ] ] ]
				whileFalse: [ output nextPut: stream next ].
			[ stream atEnd or: [ stream peek = $/ or: [ stream peek isSeparator not ] ] ]
				whileFalse: [ stream next ] ]);
		yourself.
	[ stream atEnd or: [ stream peek = $/ ] ] whileFalse: [
		element 
			attributeAt: (String streamContents: [ :output |
				[ stream atEnd or: [ stream peek = $/ or: [ stream peek = $= or: [ stream peek isSeparator ] ] ] ]
					whileFalse: [ output nextPut: stream next ].
				[ stream atEnd or: [ stream peek = $/ or: [ stream peek ~= $= ] ] ]
					whileFalse: [ stream next ].
				[ stream atEnd or: [ stream peek = $/ or: [ stream peek isSeparator not ] ] ]
					whileFalse: [ stream next ] ])
			put: (String streamContents: [ :output |
				stream peek = $"
					ifTrue: [ output nextPutAll: (stream next; upTo: $") ]
					ifFalse: [
						[ stream atEnd or: [ stream peek = $/ or: [ stream peek isSeparator ] ] ]
							whileFalse: [ output nextPut: stream next ] ] ]).
			[ stream atEnd or: [ stream peek = $/ or: [ stream peek isSeparator not ] ] ]
				whileFalse: [ stream next ] ].
	^ element.
	! !

!PRTextParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/18/2006 15:55'!
reduceActionForAny1: nodes 
	^ self parseText: (nodes at: 1) value.! !

!PRTextParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/18/2006 15:55'!
reduceActionForLine1: nodes 
	^ items.! !

!PRTextParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/18/2006 15:55'!
reduceActionForLineItem1: nodes 
	^ self addText: (nodes at: 1).! !

!PRTextParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/18/2006 15:55'!
reduceActionForLineItem2: nodes 
	^ self addLink: (nodes at: 1).! !

!PRTextParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/18/2006 15:55'!
reduceActionForLineItem4: nodes 
	^ self addText: (nodes at: 1).! !

!PRTextParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/18/2006 15:55'!
reduceActionForLink1: nodes 
	^ self parseLink: (nodes at: 1) value.! !

!PRTextParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/18/2006 15:55'!
reduceActionForRepeatXXLineItem1: nodes 
	^ OrderedCollection new.! !

!PRTextParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/18/2006 15:55'!
reduceActionForRepeatXXLineItem2: nodes 
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself.! !

!PRTextParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/18/2006 15:55'!
reduceActionForText1: nodes 
	^ self parseText: (nodes at: 1) value.! !

!PRTextParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/18/2006 15:55'!
reduceActionForText2: nodes 
	^ self parseText: (nodes at: 1) value allButFirst.! !

!PRTextParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/18/2006 15:55'!
reduceActionForXml1: nodes 
	^ self closeTag: (self 
				parseXml: (nodes at: 1) value
				start: 3
				end: 1).! !

!PRTextParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/18/2006 15:55'!
reduceActionForXml2: nodes 
	^ self shortTag: (self 
				parseXml: (nodes at: 1) value
				start: 2
				end: 2).! !

!PRTextParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/18/2006 15:55'!
reduceActionForXml3: nodes 
	^ self openTag: (self 
				parseXml: (nodes at: 1) value
				start: 2
				end: 1).! !

!PRTextParser methodsFor: 'generated-tables' stamp: 'lr 2/18/2006 15:55'!
reduceTable
	^#(
#(8 1 #reduceActionForXml1:)
#(8 1 #reduceActionForXml2:)
#(8 1 #reduceActionForXml3:)
#(9 1 #reduceActionForLineItem1:)
#(9 1 #reduceActionForLineItem2:)
#(9 1 #reduceFor:)
#(9 1 #reduceActionForLineItem4:)
#(10 1 #reduceActionForLink1:)
#(11 1 #reduceActionForText1:)
#(11 1 #reduceActionForText2:)
#(12 1 #reduceFor:)
#(13 1 #reduceActionForLine1:)
#(14 0 #reduceActionForRepeatXXLineItem1:)
#(14 2 #reduceActionForRepeatXXLineItem2:)
#(15 1 #reduceActionForAny1:)
)! !

!PRTextParser methodsFor: 'adding-xml' stamp: 'lr 2/18/2006 15:45'!
shortTag: aXmlTag
	items addLast: aXmlTag.! !

!PRTextParser methodsFor: 'generated-tables' stamp: 'lr 2/18/2006 15:55'!
transitionTable
	^#(
#(3 54 1 54 2 54 3 54 4 54 5 54 6 54 7 9 13 13 14 54 16)
#(2 0 16)
#(3 17 1 21 2 25 3 29 4 33 5 37 6 41 7 45 8 49 9 53 10 57 11 61 15 50 16)
#(2 34 1 2 3 4 5 6 7 16)
#(2 6 1 2 3 4 5 6 7 16)
#(2 10 1 2 3 4 5 6 7 16)
#(2 14 1 2 3 4 5 6 7 16)
#(2 42 1 2 3 4 5 6 7 16)
#(2 38 1 2 3 4 5 6 7 16)
#(2 62 1 2 3 4 5 6 7 16)
#(2 26 1 2 3 4 5 6 7 16)
#(2 58 1 2 3 4 5 6 7 16)
#(2 22 1 2 3 4 5 6 7 16)
#(2 18 1 2 3 4 5 6 7 16)
#(2 30 1 2 3 4 5 6 7 16)
)! !

!MAStringWriter methodsFor: '*pier-model-visiting-description' stamp: 'lr 11/17/2005 15:17'!
visitStructureDescription: aDescription
	stream nextPutAll: (PRPathReference to: self object).! !

!UndefinedObject methodsFor: '*pier-model' stamp: 'lr 4/17/2005 11:57'!
accept: aVisitor
	"do nothing"! !

!Collection methodsFor: '*pier-model' stamp: 'lr 4/17/2005 11:57'!
accept: aVisitor
	aVisitor visitAll: self.! !

Collection subclass: #PRIndexedCollection
	instanceVariableNames: 'collection indexes selectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Utilities'!

!PRIndexedCollection class methodsFor: 'instance-creation' stamp: 'lr 4/17/2005 11:59'!
on: aCollection selectors: aSelectorCollection
	^ self new
		setCollection: aCollection;
		setSelectors: aSelectorCollection;
		rehash;
		yourself.! !

!PRIndexedCollection methodsFor: 'private-index' stamp: 'lr 1/3/2006 09:42'!
addIndexed: anObject
	self indexes keysAndValuesDo: [ :key :value |
		(value 
			at: (anObject perform: key)
			ifAbsentPut: [ Set new ])
				add: anObject ].! !

!PRIndexedCollection methodsFor: 'forwarding' stamp: 'lr 4/17/2005 11:58'!
add: anObject
	self collection add: anObject.
	self addIndexed: anObject.
	^ anObject.! !

!PRIndexedCollection methodsFor: 'forwarding' stamp: 'lr 4/17/2005 11:58'!
at: aKey
	^ self collection at: aKey.! !

!PRIndexedCollection methodsFor: 'forwarding' stamp: 'lr 4/17/2005 11:58'!
at: aKey ifAbsent: aBlock
	^ self collection at: aKey ifAbsent: aBlock.! !

!PRIndexedCollection methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
collection
	^ collection! !

!PRIndexedCollection methodsFor: 'forwarding' stamp: 'lr 4/17/2005 11:58'!
do: aBlock
	self collection do: aBlock.! !

!PRIndexedCollection methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
indexes
	^ indexes! !

!PRIndexedCollection methodsFor: 'accessing-index' stamp: 'lr 1/3/2006 09:53'!
index: aSelector at: aKey
	^ (self indexes at: aSelector) 
		at: aKey 
		ifAbsent: [ Set new ].! !

!PRIndexedCollection methodsFor: 'accessing-index' stamp: 'lr 4/17/2005 11:58'!
index: aSelector at: aKey ifAbsent: aBlock
	^ (self indexes at: aSelector) 
		at: aKey ifAbsent: aBlock.! !

!PRIndexedCollection methodsFor: 'accessing-index' stamp: 'lr 4/17/2005 11:58'!
index: aSelector includes: aKey
	^ (self indexes at: aSelector) 
		includesKey: aKey.! !

!PRIndexedCollection methodsFor: 'private' stamp: 'lr 4/17/2005 11:58'!
rehash
	self setIndexes: IdentityDictionary new.
	self selectors do: [ :each | 
		self indexes 
			at: each 
			put: Dictionary new ].
	self collection do: [ :each |
		self addIndexed: each ].! !

!PRIndexedCollection methodsFor: 'private-index' stamp: 'lr 1/3/2006 09:48'!
removeIndexed: anObject
	self indexes keysAndValuesDo: [ :selector :dictionary |
		(dictionary at: (anObject perform: selector))
			remove: anObject ].! !

!PRIndexedCollection methodsFor: 'forwarding' stamp: 'lr 4/17/2005 11:58'!
remove: anObject ifAbsent: aBlock
	self collection remove: anObject ifAbsent: aBlock.
	self removeIndexed: anObject.
	^ anObject.! !

!PRIndexedCollection methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
selectors
	^ selectors! !

!PRIndexedCollection methodsFor: 'initialization' stamp: 'lr 4/17/2005 11:58'!
setCollection: aCollection
	collection := aCollection! !

!PRIndexedCollection methodsFor: 'initialization' stamp: 'lr 4/17/2005 11:58'!
setIndexes: aCollection
	indexes := aCollection! !

!PRIndexedCollection methodsFor: 'initialization' stamp: 'lr 4/17/2005 11:58'!
setSelectors: aCollection
	selectors := aCollection! !

!PRIndexedCollection methodsFor: 'forwarding' stamp: 'lr 4/17/2005 11:58'!
size
	^ self collection size.! !

!PRIndexedCollection methodsFor: 'forwarding' stamp: 'lr 4/17/2005 11:58'!
species
	^ self collection species.! !

!MAVisitor methodsFor: '*pier-model-accessing' stamp: 'lr 11/17/2005 15:17'!
context
	^ PRCurrentContext value.! !

!MAVisitor methodsFor: '*pier-model-accessing' stamp: 'lr 11/17/2005 15:17'!
context: aContext
	PRCurrentContext value: aContext.! !

!MAVisitor methodsFor: '*pier-model-visiting-description' stamp: 'lr 10/20/2005 11:17'!
visitStructureDescription: anObject
	^ self visitElementDescription: anObject.! !

Notification subclass: #PRCurrentContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Kernel'!

!PRCurrentContext class methodsFor: 'utilities' stamp: 'lr 12/24/2005 12:13'!
use: anObject during: aBlock
	^ aBlock on: self do: [ :notification | notification resume: anObject ].! !

!PRCurrentContext class methodsFor: 'accessing' stamp: 'lr 12/20/2005 15:21'!
value
	"This is the read accessor of the current context."

	| result |
	^ (result := self signal) notNil 
		ifTrue: [ result context ].! !

!PRCurrentContext class methodsFor: 'accessing' stamp: 'lr 10/20/2005 11:44'!
value: aContext
	"This is the write accessor of the current context."

	self signal context: aContext.! !

MAElementDescription subclass: #PRStructureDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Magritte'!

!PRStructureDescription class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false! !

!PRStructureDescription class methodsFor: 'accessing' stamp: 'lr 10/30/2005 12:31'!
label
	^ 'Structure'! !

!PRStructureDescription methodsFor: 'visiting' stamp: 'lr 10/12/2005 13:52'!
acceptMagritte: aVisitor
	aVisitor visitStructureDescription: self.! !

!PRStructureDescription methodsFor: 'accessing' stamp: 'lr 11/17/2005 16:09'!
kind
	^ PRStructure! !

MAError subclass: #PRStructureError
	instanceVariableNames: 'structure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Exception'!

PRStructureError subclass: #PRConflictingNameError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Exception'!

!PRConflictingNameError class methodsFor: 'instance-creation' stamp: 'lr 12/28/2005 11:47'!
in: aStructure title: aString
	^ (self structure: aStructure) 
		signal: aString printString , ' conflicts in ' , aStructure title printString.! !

PRStructureError subclass: #PRInvalidNestingError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Exception'!

!PRInvalidNestingError class methodsFor: 'instance-creation' stamp: 'lr 12/5/2005 13:26'!
of: aChildStructure in: aParentStructure
	^ (self structure: aParentStructure)
		signal: aChildStructure title printString , ' can not be a child of ' , aParentStructure title printString.! !

!PRStructureError class methodsFor: 'instance-creation' stamp: 'lr 12/5/2005 13:21'!
structure: aStructure
	^ self new
		setStructure: aStructure;
		yourself.! !

!PRStructureError methodsFor: 'initialization' stamp: 'lr 12/5/2005 13:14'!
setStructure: aStructure
	structure := aStructure! !

!PRStructureError methodsFor: 'accessing' stamp: 'lr 12/5/2005 13:15'!
structure
	^ structure! !
PRDocumentScanner initialize!
PRMacroExpander initialize!
